unit Awatimes;
{Added by A. Arnold October/November 1995.}
{----------------------------------------------------
Unit defines the routines a TimeRec structure.
TimeRec declares the time fields needed to support a
particular event; i.e., the start of a online session.
------------------------------------------------------}
interface
uses
  SysUtils;

Type
  TimeRec = Record
    iHrs, iMins, iSecs : Integer;
    sTime : String;
    rHrs : Real;
  end {TimeRec};

Procedure HMSAdd(In1, In2: TimeRec; var Out:TimeRec);
Procedure HMSSubtract(In1, In2: TimeRec; var Out:TimeRec);
                     {In1 minus In2 gives Out}
Procedure IntToHMS(H, M, S: Integer; var Out:TimeRec);

implementation
Procedure HMSAdd(In1, In2: TimeRec; var Out:TimeRec);
begin
  With Out Do
    Begin
      iHrs := In1.iHrs + In2.iHrs;
      iMins := In1.iMins + In2.iMins;
      iSecs := In1.iSecs + In2.iSecs;
      If iSecs >= 60 then
        begin
          Dec(iSecs,60);
          Inc(iMins);
        end;
      If iMins >= 60 then
        begin
          Dec(iMins,60);
          Inc(iHrs);
        end;
      IntToHMS(iHrs, iMins, iSecs, Out);
    End {With};
end {HMSAdd};

Procedure HMSSubtract(In1, In2: TimeRec; var Out:TimeRec);
begin
  With Out Do
    begin
      iHrs := 0;
      iMins := 0;
      iSecs := In1.iSecs - In2.iSecs;
      If ISecs < 0 then
        begin
          Inc(iSecs,60);
          iMins := 1;
        end;
      iMins := In1.iMins - In2.iMins - iMins;
      If iMins < 0 then
        begin
          Inc(iMins,60);
          iHrs := 1;
        end;
      iHrs := In1.iHrs - In2.iHrs - iHrs;
      If (iHrs < 0) or (iMins <0) or (iSecs < 0) then
        IntToHMS(0,0,0,Out)
      Else
        IntToHMS(iHrs, iMins, iSecs, Out);
    end {With};
end {HMSSubtract};

Procedure IntToHMS(H, M, S: Integer; var Out:TimeRec);
var
  Hr, Min, Sec :String;
begin
  Hr := IntToStr (H);
  if Length(Hr) = 1 then
    Hr := '0' + Hr;
  Min := IntToStr (M);
  if Length (Min) = 1 then
    Min := '0' + Min;
  Sec := IntToStr (S);
  if Length (Sec) = 1 then
    Sec := '0' + Sec;
  With Out Do
    begin
      sTime := Hr + ':' + Min + ':' + Sec;
      iHrs := H;
      iMins := M;
      iSecs := S;
      rHrs := iHrs + (iMins / 60) + (iSecs / 3600);
    end {With};
end {IntToHMS};

end.
 