{A note from the author:

28 October 1995
*   Thanks to Richard Hansen, this code is a LOT nicer.  There are no global
variables and the drag/drop routines work for both listboxes.  Now you can
drag and drop from either listbox, whereas before you could only drag from
one to the other.  Plus, you can drag/drop within either listbox.  Now it's
the REALLY cool listbox.

26 August 1995
*   I needed to do some spiffy things with the listboxes so I wrote this.  If it
already exists, then great, but I couldn't find it.  With this small program,
you can multi-select items from ListBox1 and drag them to ListBox2.
No big deal, except that you can INSERT a selected item into a specific spot
in the list.

*   The really cool thing here is that you can select an item in ListBox2 and
move it into a another spot within the list by using the arrows or by dragging
and dropping.  Again, I couldn't find any code that already did this.  I hope
you find this code useful, and if you do any other cool things with it, please
let me know.  This code is only lightly documented, so if you have any
questions, jsut ask.  One reason for the length of this program is that
it is relatively (dare I say it?) bug-free.  I'll probably pay for that claim.

Richard Howard 71553,2544 & Richard Hansen 70242,3367}

unit CoolBox;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    ListBox2: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure LBDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure LBDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.LBDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := (Source is TListBox);
end;

procedure TForm1.LBDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  i,j : Integer;

begin
  { make sure source and destination components are list boxes }
  if (Source is TListBox) and (Sender is TListBox) then begin
    { copy form one list to another }
    if (Source <> Sender) then begin
      { find destination position in list box }
      j := TListBox(Sender).ItemAtPos(Point(X,Y), True);

      { if not in list add at bottom }
      if (j = -1) then
        j := TListBox(Sender).Items.Count;

      { check ALL items in source list box }
      for i := 0 to TListBox(Source).Items.Count - 1 do begin
        if TListBox(Source).Selected[i] then begin
          { copy item from source to sender }
          TListBox(Sender).Items.Insert(j, TListBox(Source).Items[i]);

          { after copying, UNselect it }
          if TListBox(Source).MultiSelect then
            TListBox(Source).Selected[i] := False
          else
            TListBox(Source).ItemIndex := -1;
        end;
      end; {for}
    end

    { rearrange list }
    else begin
      {j = the item UNDER the moving, selected item}
      j := TListBox(Sender).ItemAtPos(Point(X, Y), True);

      if (j = -1) then
        j := TListBox(Sender).Items.Count - 1;

      {puts the moved item into place}
      TListBox(Sender).Items.Move(TListBox(Sender).ItemIndex, j);

      {select the item you moved}
      if TListBox(Sender).MultiSelect then
        TListBox(Sender).Selected[j] := True
      else
        TListBox(Sender).ItemIndex := j;
    end;
  end;
end; {procedure}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {I just threw these in here to look nice.  They can be pretty handy.}
  SendMessage(ListBox1.Handle, LB_SetHorizontalExtent, 1000, LongInt(0));
  SendMessage(ListBox2.Handle, LB_SetHorizontalExtent, 1000, LongInt(0));
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  i : Integer;
begin {procedure}
  if ListBox2.ItemIndex > 0 then
  begin {if}
    i := ListBox2.ItemIndex;
    ListBox2.Items.Move(i, i-1);
    ListBox2.ItemIndex := i-1;
  end; {if}
end; {procedure}

procedure TForm1.BitBtn2Click(Sender: TObject);
var
  i : Integer;
begin {procedure}
  if (ListBox2.ItemIndex < ListBox2.Items.Count-1) and
     (ListBox2.ItemIndex <> -1) then
  begin {if}
    i := ListBox2.ItemIndex;
    ListBox2.Items.Move(i, i+1);
    ListBox2.ItemIndex := i+1;
  end; {if}
end; {procedure}

end.
