{
 Designer: Craig Ward, 100554.2072@compuserve.com
 Date:     29/1/96
 Version:  1.0

 Function: TCwListBox component.

           This component descends from the standard ListBox component, but differs in
           the way that it possesses a procedure called DeleteSelected. This enables the
           list box to delete multiple selected items.

           The component also has a handler attached to its OnKeyDown event. If the delete
           key is pressed, whilst the control has focus, the DeleteSelected method is
           called.
********************************************************************************}
unit Cwlist;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TcwListBox = class(TListBox)
  private
    { Private declarations }
    procedure DelKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure DeleteSelected;
    constructor create(aOwner: TComponent); override;
  published
    { Published declarations }
  end;

procedure Register;

implementation

{register}
procedure Register;
begin
  RegisterComponents('cw_apps', [TCwListBox]);
end;

{construct}
constructor TCwListBox.create(aOwner: TComponent);
begin
 inherited create(aOwner);
  multiSelect := true;
  OnKeyDown := DelKeyDown;
end;


{***custom routine's************************************************************}

{delete selected items}
procedure TCwListBox.DeleteSelected;
var
 sList: TStringList;
 i: integer;
begin

 sList := TStringList.Create;

 try

  {add non-selected items to the string list}
  for i := 0 to (self.items.count -1) do
   begin
    if self.selected[i] = false then sList.add(self.items.strings[i]);
   end;

  self.items.clear;

  {assign the string list to the list box}
  for i := 0 to (sList.count -1) do
   begin
    self.items.add(sList.strings[i]);
   end;

 finally
  sList.free;
 end;

end;


{delete key press}
procedure TCwListBox.DelKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
 if key = VK_DELETE then
  begin
   DeleteSelected;
  end;
end;


{}
end.
