unit DBcvt;
(*
	Unit to import an ascii delmited file in to a (paradox) table
	1)	This file was formated with tabs set to 2.
	2)	On a 486/33 this parses about 200 linse per second (with 10 fields per line.)
			It's not fast but it works.

	Author: William R. Florac
  Company: FITCO, Verona, WI (wee little company from my house)
	Copyright 1995, FITCO.  All rights reserved.

 1)  Users of DBCVT (and it's components) must accept this disclaimer of
     warranty: "DBCVT is supplied as is.  The author disclaims all
     warranties, expressed or implied, including, without limitation,
     the warranties of merchantability and of fitness for any purpose.
     The author assumes no liability for damages, direct or conse-
     quential, which may result from the use of DBCVT."

	2) This component is donated to the public as public domain.

	3) This component can be freely used and distributed in commercial and private
     environments provided this notice is not modified in any way.

  4) If you do find this component handy and you feel guilty
    for using such a great product without paying someone,
    please feel free to send a few bucks ($25) to support further
    development. .  I have spent a lot of time making this VCL
		the best it can be and have included a help file to make
		it complete.

	5) This file was formatted with tabs set to 2.

	6) Thanks to all those who suggested (and got) improvements.

	Please forward any comments or suggestions to Bill Florac at:
	 	email: flash@etcconnect.com
		mail: FITCO
					209 Jenna Dr
					Verona, WI  53593

	Revision History
	1.0 	9-15-95	Initial release.
	1.1		10-23-96
				- If an error occured during reading ascii file post was still executed
					it is now inside the correct loop.
				- Lines in ascii file can now be LINELENGTH long (up to 65K).
			  - Now support Memo Fields!
				- A ';' in the first column is for remarks!
 				- Blank lines (no spaces!) are now ingnored.
 				- Quotes are only required if field contains seperater or delimiter
				- more escapes sequence added and are now enumerated.
				- made public busy flag (removed error 97)
				- cleaned up some possible memory leaks
				- added error codes 8,10,11
	1.2		11-6-95
				- Fixed exception if user field names did not match table (broken in 1.1)
				- Now check for too many records in text file
				- If field is too long, it is just truncated (1.1 put in "too big")
				- Added WriteEnable property.  If set to false Destination table is not
					accessed (and not needed).
				- When posting, now test for -1 index rather than string 'SKIP' to
					speed things up (a little)
				- Added a OnParse Event.  OnParse in called after parsing but before
          posting allowing the user to edit the data.
				-	Removed DoUpdate proceedure and put inline
				- Added OnPrePost Event. Called just before post to allow any calculated
					data on the same record.  Table is in "Insert" mode!
				- Added error 13 - conversion error when inserting data to table.
				- Renamed Property TickCount to NotifyCount
				-	Renamed OnTick to OnNotifyCount
				-	Moved dialog creates to the execute procedure rather than create
					so they are only created if needed.
				-	Removed unneeded FDestination.Edit as FDestination.Insert does this.
				-	Switched FDestination.Insert to FDestination.Append as this is more
					logical for non-indexed files.
				-	Removed FDestination.Post (except at end) becasue FDestination.Append
					does this if one is open.
				-	Fixed bug, RecordLimit only worked if NotifyCount > 0
				-	Progress Dialog is nolonger tied to NotifyCount. Progess is reported
					in 10% increments.
				-	Fixed bug causing missing records if length > 768
				-	Remove debug stuff left in in getline
				-	Fixed some bugs in "getline" for longlines and single record files
				- Limited memo records 32758 because it is the max for dbmemo.  Reports
					error if too long.
        -	Non-memo records are truncated at 255 char
				- Max fields is now 255 rather than 50
				- Redefined meaning of some of the error codes (Sorry folks)
				-	Added readonly propert ErrorLine to indicate line in ascii file that
					caused an error.
				- Added lowend limit (256) to linelength
				- If the last record did not end in a " it was tuncated by one char - fixed
				- Added NamesFirst property if field names are in the ascii table.
				- Made used of Integer and Word more consistant
				-	Added resource block in Execute to insure proper cleanup
					This required the addion of some flags.
				- BIG BUG/feature.  We were using the existing Tfields property of the
          Table.  If the table was missing some fields, it would cause problems.
					We now generate our OWN copy of the table.
				-	Modifed check on FFieldlist > MyTable.FieldCount to ignore skips
	1.3		11-28-95 (beta A)
				- added code to parse #26 at eof
				- if there were extra cr at end of file caused errors in reading
	1.3		11-28-95 (beta B)
				- Got rid of sloppy code in getline routine read buffer is
					sized at runtime to match LineLenth so files with long lines
					should run a little faster.
				- Progress is now monitored by bytes not records.  This eliminates
					the need to count the records first! <Darral Wagoner>
				- Progress is now in increments of 1%
	1.3 	12-2-95 (beta C)
				- If FTickCount (nofifyCount) = 0 then the cancel button on the
					progress dialog does not get called. Therefore, the button is no
					longer displayed if FTickCount = 0;
				-	Added property to change update mode of table
					mCopy - erase and replace
					mAppend - add to existing table
					mUpdate - update existing only
					mAppendUpdate - add to existing table and update existing
				- Added AbortOnKeyVoil property to allow ignoring of key violation
				- Added runtime variable KeyViolationCount to count key violations
				- Added FixedWidth property to read fixed with ascii files
					length is determined by adding a comma and with after the field
					name in fieldlist strigs.  NamesFirst does not work with fixed width
					files.
	1.3 	12-3-95 (beta D)
				- Added return variable to OnPrePost to allow cancelling a post by
					the application.
				- Added public variables to show count of appended, updated,
					and aborted.
				- Changed key in GetLine to LF rather than CR so it will work
					with UNIX files.
				- Improved parsing with escaped characters so parsing is done without
					the escaped characters involved.
	1.3 	12-4-95 (beta E)
				-	Improved handling of escapes by sacrificing some memory.
				- Made BinArray in ParseLine a constant.
	1.3		1/7/95
				-	Released

	1.4 	2/10/96
				- If last ascii record was an null, the string would be terminated
          in a coma, the last record would be skipped and the record count
          would be off by one.
				- added support of the \0 escape of null and fixed some other bugs
					with escapes in both CSV and fixed file types.
				- added EndOfRecord property.  The default is #10.  This will work with
          #13#10 or just #10.  If another value is set, all #13 and #10's are
          removed.  This allows multiline records.
				- removed restriction on using char #255 in ascii file.

- Note for help file: strings cannot contain #0

***
	Other ideas (some day):
		-	allow white space arround seperaters
		- add procedure to write ascii file
		- autocreate of table if it does not exist
    - allow filtering (excluding) records
    - direct calls to BDE to speed up!
		- use database width as default!
		- GUI field list generator
		- User definable EOR
***
	Bugs
		- should we get and pass TDataset not TTable?
		- Escapes with fixed format is fucked up

Suppored:
		paradox				Tfield				example							notes
		----------    -----------   ------------        ------------
		Alpha					ftString      "<text>"						(255 char max)
		Number				ftFloat				"100.00"						(no ,)
		Money					ftCurrency    "12.75"							(no $, )
		Short					ftSmallInt		"100"       				(-32,768 to 32,767)
		LongInt				ftInteger     "100000: 						(-2,147,483,648 to 2,147,483,647)
		BCD						ftBCD         "100.00"						(18 digits)
		Data					ftDate        "11/15/95"
		Time					ftTime        "2:30pm" or "14:00"
		TimeStamp			ftDateTime    "1/1/96 6:00am"
		Memo					ftMemo        "<text>"						(65000 char max)
		Formated Memo ftBlob   			No support
		Graphic				ftGraphic     No support
		OLE						ftBlob      	No support
		Logical				ftBoolean			"F" or "False"
		AutoIncrement ftInteger   	No support
		Binary				ftBlob      	No support
		Bytes					ftBytes     	No support

	For all above decimals can be represented as 10.10E10.
*)

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBtables, DB, StdCtrls;

const
	DBcvtVersion = '1.3 release';
	MaxFields = 255;


type
	{escape enumberations}
	Ta2dbEscape =  (esNL, esCR, esHT, esBslash, esSquote, esDquote, esQues, esNull);
	Ta2dbEscapes = set of Ta2dbEscape;

  Ta2DbMode = (mCopy, mAppend, mUpdate, mAppendUpdate);

	{my parse event}
	TParseEvent = procedure(Sender: TObject; var ParsedStrings: TStringList) of object;
	TPrePostEvent = procedure(Sender: TObject; var ATable: TTable; var OkToPost: boolean) of object;

  TAscii2DB = class(TComponent)
  private
    { Private declarations }
		Fdelimiter: char;
		Fseparator: char;
		FEndOfRecord: char;
		FEscapes: Ta2dbEscapes;
    FShowDlg: boolean;
		FNotifyCount: word;
		FLineLength: word;
		FRecordLimit: longInt;
    FDestination: TTable;
    FAsciiFile: TFileName;
		FFieldList: tstrings;
		FOnNotify: TNotifyEvent;
		FOnParse: TParseEvent;
		FOnPrePost: TPrePostEvent;
		FWriteEnable: boolean;
		FNamesFirst: boolean;
		FAbortOnKeyViol: Boolean;
		FMode: Ta2DbMode;
		FFixedWidth: boolean;
		procedure SetFieldList(value: TStrings);
		procedure SetCount(value: LongInt);
		procedure SetLineLength(value: word);
		procedure SetNamesFirst(value: boolean);
		procedure SetFixedWidth(value: boolean);
		procedure SetEndOfRecord(value: char);
		procedure AbortTransfer(Sender: TObject);
  protected
    { Protected declarations }
		EditMode: Ta2DbMode;
		MyFieldWidths: array[0..MaxFields] of word;  {width of each field}
		function Parseline(Pline: Pchar; var list: TStringList; FillList: boolean): word;
		function ParseFixedline(Pline: Pchar; var list: TStringList): word;
		function GetLine(var F: file; var Line: Pchar): boolean;
  public
    { Public declarations }
		Busy: boolean;							{busy}
		ErrorCode: word;						{cause of failure }
		ErrorLine: longInt;					{last line read from file}
		AbortedCount: LongInt; 	{record aborted during OnPrePost}
		AppendedCount: longInt;			{record appended}
		KeyViolationCount: LongInt; {records with key violations}
		ParsedCount: longInt;				{lined read from file, except cr and eof}
		UpdatedCount: longInt;			{records updated}
		constructor Create(Aowner: Tcomponent); override;
		destructor Destroy; override;
		procedure Execute;
		function GetErrorString(Ecode: word): string;
		function GetRecordCount:LongInt;
		procedure StopExecute;
  published
    { Published declarations }
		property AbortOnKeyViol: Boolean read FAbortOnKeyViol write FAbortOnKeyViol default true;
    property AsciiFile: TFileName read FAsciiFile write FAsciiFile;
		property Delimiter: char read Fdelimiter write Fdelimiter default '"';
    property Destination: TTable read FDestination write FDestination;
    property Escapes: Ta2dbEscapes read FEscapes write FEscapes default [];
		property FieldList: TStrings read FFieldList write SetFieldList;
		property FixedWidth: boolean read FFixedWidth write SetFixedWidth default false;
		property LineLength: word read FLineLength write SetLineLength default 256;
    property Mode: Ta2dbMode read FMode write FMode default mCopy;
		property NamesFirst: boolean  read FNamesFirst write SetNamesFirst default false;
		property NotifyCount: word read FNotifyCount write FNotifyCount default 100;
		property RecordLimit: LongInt read FRecordLimit write SetCount default 0;
		property Separator: char read Fseparator write Fseparator default ',';
		property ShowDlg: boolean read FshowDlg write FShowDlg default false;
		property WriteEnable: boolean read FWriteEnable write FWriteEnable default true;
		property EndOfRecord: char read FEndOfRecord write SetEndOfRecord default #10;

		property OnNotifyCount: TnotifyEvent read FOnNotify write FOnNotify;
		property OnParse: TParseEvent read FOnParse write FOnParse;
		property OnPrePost: TPrePostEvent read FOnPrePost write FOnPrePost;
  end;

procedure Register;
function Alltrim(S: String): string;

implementation

constructor TAscii2DB.Create(Aowner: Tcomponent);
begin
	inherited create(Aowner);
	{set default properties}
	Busy := false;
	Fdelimiter := '"';
	Fseparator := ',';
	FEndOfRecord := #10;
	FEscapes := [];
  FShowDlg := False;
	FNotifyCount := 100;
	FLineLength := 256;
	FRecordLimit := 0;
	FWriteEnable := true;
	FNamesFirst := false;
	FMode := mCopy;
	FAbortOnKeyViol := true;
  FFixedWidth := false;

	{create some things needed}
	FFieldList := Tstringlist.create;
  FFieldList.Clear;

	end; {of create}


destructor TAscii2DB.Destroy;
begin
	FFieldList.Free;
	inherited destroy;
	end; {of destroy}

procedure Tascii2DB.Execute;
var
	ParsedList: tstringlist;		{a place to put parsed strings}
	InFile: File;								{file we are reading}
	Pline: Pchar;								{a pointer}
	DBIndex: word;  						{an index}
	{these should have been TLists but I was lazy}
	MyFields: array[0..MaxFields] of TField;  {field associated with each in list}
	BigText: array[0..MaxFields] of TmemoryStream; 	{streams for memo fields}
	NumberOfFields: word;					{fields parsed}
  NewRect: TRect;							{a rectangle}
	EndOfIt: LongInt;						{number of records to be processed}
	PText: String;							{a string}
	ProgressForm: TForm;				{progress dialog}
	ProgressCancel: TButton;		{cancel button in progress dialog}
	ProgressTick: LongInt;			{a bytes between dlg updates}
	NextTick: LongInt;					{a counter of bytes parsed}
	X: word;										{a counter}
	FirstPosition: LongInt;			{pointer to first record in ascii file}
	MyTable: TTable;						{copy of table}
	MyIndexField: word;
	FieldName: string;
  FieldWidth: word;
	EndFieldName: byte;
	OkToPost: Boolean;
	AppendingRecord: boolean;

{local procedure}
procedure UpdateDlg;
var
	GPercent: word;			{graphical progress in percent}
	TPercent: word;			{text progress in percent}
begin
	if FileSize(Infile) > 0 then begin
		GPercent := ProgressForm.ClientWidth * (FilePos(Infile) +1) div FileSize(Infile);
		TPercent := 100 * (FilePos(Infile) +1) div FileSize(Infile);
		end
  else begin
		GPercent := 0;
		TPercent := 0;
		end;

	{draw left background}
	if FNotifyCount > 0
	then NewRect := Rect(0, 0, GPercent, ProgressForm.ClientHeight div 2)
	else NewRect := Rect(0, 0, GPercent, ProgressForm.ClientHeight);
	ProgressForm.Canvas.Brush.Style := bsSolid;
	ProgressForm.Canvas.Brush.Color := clRed;
	ProgressForm.Canvas.FillRect(NewRect);

	{draw right background}
	if FNotifyCount > 0
	then NewRect := Rect(GPercent, 0, ProgressForm.ClientWidth,
              ProgressForm.ClientHeight div 2)
  else NewRect := Rect(GPercent, 0, ProgressForm.ClientWidth,
              ProgressForm.ClientHeight);

	ProgressForm.Canvas.Brush.Color := clBtnFace;
	ProgressForm.Canvas.FillRect(NewRect);
	{draw text}
	pText := IntToStr(TPercent) + '%';
	ProgressForm.Canvas.Brush.Style := bsClear;
  ProgressForm.Canvas.TextOut(90,2,Ptext);
	end; {of UpdateDlg}

begin {of Execute}
 	{abort if we are busy}
	if busy then exit;
	try
  Busy := true;

	{assume good}
	ErrorCode := 0;
	ErrorLine := 0;
	FirstPosition := 0;

	ParsedList := nil;
	ProgressForm := nil;
	ProgressCancel := nil;
	ParsedCount := 0;
  AbortedCount := 0;
	UpdatedCount := 0;
	AppendedCount := 0;
	KeyViolationCount := 0;

	NextTick := 0;
	Pline := nil;
	MyTable := nil;

	{clear arrays}
	for X := 0 to MaxFields - 1 do begin
		BigText[x] := nil;
		MyFields[x] := nil;
		end;

	TfileRec(InFile).Mode := fmClosed; {trick to know if we have assigned file}

	{does source file exist?}
	if not FileExists(FAsciiFile) then begin
		errorCode := 2;
		busy := false;
		exit;
		end;

	{open ascii file}
	try
		AssignFile(InFile, FAsciiFile);
		Reset(InFile,1);
	except
		on EInOutError do begin
			errorCode := 10;
			exit;
			end;
		end;

	{make objects}
	ParsedList := TStringList.create; 		{create the string list}
	ParsedList.Clear;
	pLine := StrAlloc(FLineLength + 1); 	{get me a string block}
	pLine[0] := #0;

	{read first line and create fields if asked to}
	if FNamesFirst and not FFixedWidth then begin
		while not EOF(InFile) do begin
			{save pointer to begining LAST of line}
			FirstPosition := FilePos(Infile);
			if not GetLine(InFile, pLine) then begin
				ErrorCode := 9;
				exit;
				end;
	 	  if (Pline[0] <> #0) and (PLine[0] <> ';') then break;
    	end;

		{get record count, if fill = false, parselist is not modified}
		NumberOfFields := ParseLine(PLine, ParsedList, false);
		if NumberOfFields = 0  then begin
			errorCode := 5;
			exit;
			end;

		{add fields as needed}
		for x := 1 to NumberOfFields do ParsedList.Add('');

		{return to save spot and now read strings}
		Seek(InFile,FirstPosition);
		if not GetLine(InFile, pLine) then begin
			ErrorCode := 9;
			exit;
			end;

		{call again and fill}
		NumberOfFields := ParseLine(PLine, ParsedList, true);
		if NumberOfFields = 0  then begin
			errorCode := 5;
			exit;
			end;
		{copy to field list}
		FFieldList.clear;
		FFieldList.assign(ParsedList);
		ParsedList.clear;
		FirstPosition := FilePos(Infile);
		end;

	{make sure table is working}
	if FWriteEnable then begin
		if (FDestination = nil)
		or (FDestination.DataBaseName = '')
		or (FDestination.TableName = '')
		then begin
			ErrorCode := 99;
			exit;
			end;

		{table must be inactive, so we can get exclusive}
		if FDestination.Active then FDestination.Active := False;

		{create my own TTable. This give me default Fields as 1:1 of FieldDefs
		 and includes ALL the fields.}
		MyTable := TTable.Create(Self);
		MyTable.DatabaseName := FDestination.DatabaseName;
		MyTable.TableName := FDestination.TableName;
		MyTable.TableType := FDestination.TableType;
		MyTable.Exclusive := True;

		{open database}
		try
			MyTable.Open;
		except
			on e: EDatabaseError do begin
        PText := e.message;
				MyTable.Exclusive := False;  {release control}
				errorCode := 3;
				exit;
				end;
			end;
		end;

		{if user list is longer then tables}
		X := 0;
		for DBIndex := 0 to FFieldList.Count - 1 do begin
			if UpperCase(FFieldList[DBIndex]) <> 'SKIP' then inc(X);
			end;

		if X > MyTable.FieldCount then begin
			errorCode := 11;
			exit;
    	end;
		{copy table}

	{if we are in update mode, one of the ascii fields must be the }
	{index key, find it.}
	if FWriteEnable then begin
  	EditMode := Fmode;
		if (EditMode = mAppendUpdate) or (EditMode = mUpdate) then begin
			{must have index to do update}
			if MyTable.IndexFieldCount = 0 then begin
				ErrorCode := 15;
				exit;
      	end;
			MyIndexField := 0;
		  for DBIndex := 0 to FFieldList.count -1 do begin
				if MyTable.FindField(FFieldList[DBIndex]) = MyTable.IndexFields[0] then begin
					MyIndexField := DBIndex + 1;
					break;
					end;
				end;
			if MyIndexField = 0 then begin
				ErrorCode := 16;
				exit;
				end
			else dec(MyIndexField); {zero base it}
			end;
		end;

	{can we find all the field names?, create OUR fields for them}
	for DBIndex := 0 to FFieldList.Count - 1 do begin
		ParsedList.Add('');
		FieldName := UpperCase(FFieldList[DBIndex]);
		EndFieldName := Pos(',',FieldName);
		if FFixedWidth then begin
			FieldWidth := StrToIntDef(copy(FieldName,EndFieldName + 1, integer(FieldName[0])),0);
			if FieldWidth > 0
      then MyFieldWidths[DBIndex] := FieldWidth
      else begin
				ErrorCode := 17;
				exit;
				end;
			end;
		if EndFieldName > 0 then FieldName := Copy(FieldName,0,EndFieldName - 1);

		if FieldName <> 'SKIP' then begin
			if FWriteEnable then begin {only if enabled}
				{get pointer to field}
				MyFields[DBIndex] := MyTable.FindField(FieldName);

				{exit if we did not find it}
				if MyFields[DBIndex] = nil then begin
					errorCode := 8;
					exit;
					end;

				{Special handling of memo fields}
				if MyFields[DBindex].DataType = ftMemo then begin
					{create stream assign to list}
					BigText[DBIndex] := TMemoryStream.Create;
					(BigText[DBIndex] as TMemoryStream).Clear;
					ParsedList.Objects[DBIndex] := BigText[DBIndex];
					end;
				end; {of if WriteEnable}
			end; {of if SKIP}
		end; {of for}

	{create dialog if needed}
	if FShowDlg then begin
		{setup ticker}
		ProgressTick := FileSize(InFile) div 100;
		if ProgressTick = 0 then begin
			ProgressTick := FileSize(InFile) div 10;
			if ProgressTick = 0 then ProgressTick := 1;
			end;

		{ok create controls}
		ProgressForm := TForm.Create(Self);
		with ProgressForm do begin
			Parent := Parent;
			ClientWidth := 200;
    	if FNotifyCount > 0
			then ClientHeight:= 40
			else ClientHeight:= 20;
			BorderStyle := bsSingle;
			BorderIcons := [];
			Caption := 'Transfer Progress';
			FormStyle := fsStayOnTop;
			end;

		if FNotifyCount > 0 then begin
			ProgressCancel := Tbutton.Create(Self);
			with ProgressCancel do begin
				Parent := ProgressForm;
				left := 0;
				width := ProgressForm.ClientWidth;
				top := ProgressForm.ClientHeight div 2 ;
				height := top;
				caption :='&Cancel';
				OnClick := AbortTransfer;
				end;
			end;
    ProgressForm.Left := TForm(Owner).Left + (TForm(Owner).Width div 2) - ProgressForm.Width div 2;
		ProgressForm.Top := TForm(Owner).Top + (TForm(Owner).Height div 2) - ProgressForm.Height div 2;
		ProgressForm.Show;
		ProgressForm.Update;
		end;

	{we are ready so empty old data}
	if FWriteEnable then begin
		if EditMode =	mCopy then MyTable.EmptyTable;
		end;

	{rip through file}
	while (not eof(InFile)) and (errorCode = 0)do begin
		{count lines}
		inc(ErrorLine);

		{get a line}
		if not GetLine(InFile, Pline) then begin
			errorCode := 9;
			break;
     	end;
		{ignore comments and blanks}
    if (Pline[0] = #0) or (PLine[0] = ';') then continue;

		{parse the line, cool! I've attached memos to the list}
		if not FFixedWidth
		then	NumberOfFields := ParseLine(PLine, ParsedList, true)
		else NumberOfFields := ParseFixedLine(PLine, ParsedList);

		{did we parse the expecte amount of fields}
		if NumberOfFields <> FFieldList.Count then begin
			errorCode := 5;
			break;
			end;

		{give user chance to modify event}
		if assigned(FOnParse) then FOnParse(Self, ParsedList);

    {This is part that is slow!}
		if FWriteEnable then begin
			{see if record exist, if so, update it!}
			try
				if ((EditMode = mAppendUpdate) or (EditMode = mUpdate)) and Mytable.FindKey([ParsedList[MyIndexField]])
				then begin
					MyTable.Edit;
					AppendingRecord := false;
					end
    		else begin
					if EditMode = mUpdate {no appends in mUpdate}
					then break
					else begin
						MyTable.Append; {puts in edit mode}
						AppendingRecord := true;
          	end;
					end;
 			except
				on EDBEngineError do begin
					{other error}
       		errorCode := 13;
					break;
					end;
    	  end; {of try}
			for DBIndex := 0 to FFieldList.Count - 1 do begin
				if MyFields[DBIndex] <> nil then begin
					try
						if BigText[DBindex] <> nil then begin {is a memo}
							if (ParsedList.Objects[DBindex] as TmemoryStream).size <= 32758 then
              	(MyFields[DBindex] as TMemoField).LoadFromStream
								(ParsedList.Objects[DBindex] as TmemoryStream)
							else begin
								errorCode := 4;
								break;
								end
							end
  	  			else MyFields[DBindex].AsString := AllTrim(ParsedList[DBIndex]);
	        except
						on EConvertError do begin
							errorCode := 13;
							break;
							end;
						on EDataBaseError do begin
							errorCode := 7;
							break;
							end;
	  	      end; {of try}
					end; {if if >= 0}
    	  end;  {of for}
	    end; {of if WriteEnabled;}
	  inc(ParsedCount);

		{call OnPrePost for user}
		OkToPost := true;
   	if assigned(FOnPrePost) then FOnPrePost(Self,MyTable,OKtoPost);

		try
		if OkToPost
		then begin
    	MyTable.Post;
			if AppendingRecord
			then inc(AppendedCount)
			else inc(UpdatedCount);
			end
		else begin
			MyTable.Cancel;
			inc(AbortedCount);
			end;
 		except
			on E: EDBEngineError do begin
				{key violation?}
				if E.Errors[0].ErrorCode = 9729 then begin
					if FAbortOnKeyViol then begin
						errorCode := 14;
						break;
						end
					else begin
						{cancel post}
						MyTable.Cancel;
						inc(KeyViolationCount); {count key violations}
						end;
          end
				else begin
					{other error}
					errorCode := 13;
					break;
					end;
				end;
			end; {of try}

		{call user update and give some time to other apps}
		if FNotifyCount > 0 then begin
			if ParsedCount mod FNotifyCount = 0 then begin
				Application.ProcessMessages;
				if assigned(FOnNotify) then FOnNotify(Self);
  			end; {of ParsedCount...}
			end; {of FNotifyCount...}

		{update dialog}
		if FShowDlg and (FilePos(InFile) > NextTick) then begin
			NextTick := FilePos(InFile) + ProgressTick;
			UpdateDlg;
			end;
		{abort?}
		if (FRecordLimit > 0) and (ParsedCount >= FRecordLimit) then break;
 		end; {of while not eof...}

	{last update of dialog}
	if errorCode = 0 then begin
		if FShowDlg then UpdateDlg;
		end;

	{see if we have any key violation errors}
	if KeyViolationCount > 0 then ErrorCode := 14;

	{clear error line}
	if errorCode = 0 then begin
		ErrorLine := 0;
		end;


	{ok, shut it all down and clean up what we created}
	finally
		{close ascii file}
		if TfileRec(InFile).Mode <> fmClosed then Close(InFile);
		{delete string list}
		if ParsedList <> nil then ParsedList.Free;
		{delete things we created}
		if Pline <> nil then  StrDispose (Pline);
		{Delete OUR fields}
		for X := 0 to FFieldList.Count - 1 do begin
			if BigText[X] <> nil then BigText[X].Free; {delete memorystreams}
    	end;
		{Close table}
		if MyTable <> nil then begin
			MyTable.Close; {close the database}
			MyTable.Exclusive := False;  {release control}
			MyTable.Free;
			end;

		{nuke progress window (and memory for it)}
		if ProgressCancel <> nil	then ProgressCancel.Free;
		if ProgressForm <> nil then begin
			ProgressForm.Close;
			ProgressForm.Free;
			end;

		{we're done!}
		busy := false;
	end;
	end; {of execute}

procedure Tascii2DB.AbortTransfer(Sender: TObject);
begin
	ErrorCode := 98;
	end; {of aborttranfer}

function Tascii2DB.GetErrorString(Ecode: word): string;
begin
	case eCode of
		0: result := 'No errors detected.';
		1: result := 'Can not get exclusive access to table.';
	 	2: result := 'Ascii file does not exist: [' + FAsciiFile + ']';
		3: result := 'Can not open table: [' + FDestination.TableName + ']';
		4: result := 'Record to long for memofield.';
		5: result := 'Field count does not match ascii file.';
		6: result := ''; {not used}
		7: result := 'Data type mismatch in ascii file.';
		8: result := 'Field names do not match table.';
		9: result := 'Line too long: [' + IntToStr(Errorline) + ']';
		10: result := 'Could not open ascii file: [' + FAsciiFile + ']';
		11: result := 'More fields to parse than in table.';
		12: result := ''; {not used}
		13: result := 'Conversion Error.';
		14: result := 'Key violation error.';
		15: result := 'Table is not indexed.';
		16: result := 'Index field not found in ascii file.';
		17: result := 'Invalid field width';

		98: result := 'User aborted.';
		99: result := 'Desitination table does not exist.';
	  else result := 'Unknown error.';
		end;
	end; {of get errorstring}

function Tascii2DB.GetRecordCount: LongInt;
var
	InFile: File;
	PLine: Pchar;
	counter: Longint;
begin
	{allow busy only if called from execute routine}
	if busy then begin
		Result := -1;
		exit;
		end;
	try

	{init things}
	Result := 0;
	ErrorCode := 0;
	counter := 0;

	{see if file exist}
	if not FileExists(FAsciiFile) then begin
		ErrorCode := 2;
		exit;
		end;

	{open file}
	try
		AssignFile(InFile, FAsciiFile);  {open ascii file}
		Reset(InFile,1);
	except
		on EInOutError do begin
			errorCode := 10;
			busy := false;
			exit;
			end;
    end;

	{get me some space}
	Pline := StrAlloc(FLineLength + 1);
	Pline[0] := #0;

	{count the lines}
	while not EOF(InFile) do begin
		if not GetLine(InFile, pLine) then begin
			errorCode := 9;
			break;
			end
		else begin
      if (Pline[0] = #0) or (PLine[0] = ';') then continue;
			inc(counter);
			end;
		end;
	{close source file}
	CloseFile(InFile);
  {clean up whate we took}
	Result := counter;

	finally
	StrDispose (Pline);
	end;
	end; {of getrecordcount}


procedure Tascii2DB.StopExecute;
begin
	{setting error code aborts}
	ErrorCode := 98;
	end; {of StopExecute}


procedure Tascii2DB.SetFieldList(Value: TStrings);
begin
  FFieldList.Assign(Value);
	end; {of setfieldlist}

procedure Tascii2DB.SetCount(value: LongInt);
begin
	if value < 0 then value := 0;
  FRecordLimit := value;
	end; {of setcount}

procedure Tascii2DB.SetLineLength(value: word);
begin
	if value > 65000 then value := 65000;
	if value < 256 then value := 256;
  FLineLength := value;
	end; {of setcount}

procedure Tascii2DB.SetNamesFirst(value: boolean);
begin
	{First names can not be set on fixed width files}
	if (value = true) and (FFixedWidth = false)
	then FNamesFirst := true
	else FNamesFirst := value;
	end;

procedure Tascii2DB.SetFixedWidth(value: boolean);
begin
	{Fixed width can not be set on files with first names}
	if (value = true) and (FFixedWidth = false)
	then FFixedWidth := true
	else FFixedWidth := value;
	end;

procedure Tascii2DB.SetEndOfRecord(value: char);
begin
	{#0 not allowed!}
	if value < #1 then value := #10;
  FEndOfRecord := value;
	end; {of setcount}


function Tascii2DB.parseline(pLine: pchar; var list: tstringlist; FillList: boolean): word;
const
	BinArray: array[0..9] of char = '",--------';

var
	index: word;
	x: word;
	InQuote: boolean;
  MaxCount: word;
	AttachToLast: boolean;
	ptLine,ptAttr, ptCopy, pStart, pEnd: Pchar;
	pCopy,	pAttr: Pchar;
  aRecordCount: word;
	LastChar: Char;
	fWidth: word;
	s: string;

begin
{  *** parse line ***
	- look for separator marker or ENDOFLINE (EOR)
	  separator can not be inbetween DELIMITERS
	 	(if it is, it is part of the string)
	- pull out segment and delete from string
  - for each segment,
	  	see if first character = " if so, nuke it
		  see if last character = " if so, nuke it
 			look for \" if found convert it to " (if enabled)
 			add to stringlist
}
	{default to error}
	result := 0;
	{abort if 0 length string}
  if Pline[0] = #0  then begin
		exit;
	end;

try
	{set these to nil so dispose will ignore them}
	pAttr := nil;
	pCopy := nil;

{change escaped characters}
{	- ok we have to mark the escaped characters.  We will do this with a
    #255 and save the correct value in an attribute array.  After parsing
		we will put back.  We need to remove the escaped codes before parsing
		so the escaped characters don't cause problems with the parsing.
}

  if not (Escapes = []) then begin
		{create array for extended attibutes and copy}
		pAttr := StrAlloc(FLineLength + 1); 	{get me a string block}
		pCopy := StrAlloc(FLineLength + 1); 	{get me a string block}

		{set some temp pointers}
		ptLine := pLine;
		ptAttr := pAttr;
		ptCopy := pCopy;
		while ptLine <= StrEnd(pLine) do begin  {up to but not including #0}
			{default no attr}
			ptAttr^ := #0;
			if ptLine^ = '\' then begin
				{default}
				ptCopy^ := ptLine^;
				{look at next char}
				inc(ptLine);
				case ptLine^ of
					't': {Horz tab}
						if (esHT in Escapes) then begin ptCopy^ := #255; ptAttr^ := #9; end
						else begin inc(ptCopy); inc(ptAttr); ptCopy^ := ptLine^; end;
					'n': {newline}
						if (esNL in Escapes) then begin ptCopy^ := #255; ptAttr^ := #10; end
						else begin inc(ptCopy); inc(ptAttr); ptCopy^ := ptLine^; end;
					'r': {CR}
						if (esCR in Escapes) then begin ptCopy^ := #255; ptAttr^ := #13; end
						else begin inc(ptCopy); inc(ptAttr); ptCopy^ := ptLine^; end;
					'\': {back slash}
						if (esBSlash in Escapes) then begin ptCopy^ := #255; ptAttr^ := '\'; end
						else begin inc(ptCopy); inc(ptAttr); ptCopy^ := ptLine^; end;
					#34: {double quote}
						if (esDQuote in Escapes) then begin ptCopy^ := #255; ptAttr^ := #34; end
						else begin inc(ptCopy); inc(ptAttr); ptCopy^ := ptLine^; end;
					#39: {single quote}
						if (esSQuote in Escapes) then begin ptCopy^ := #255; ptAttr^ := #39; end
						else begin inc(ptCopy); inc(ptAttr); ptCopy^ := ptLine^; end;
					'?': {double quote}
						if (esQues in Escapes) then begin ptCopy^ := #255; ptAttr^ := '?'; end
						else begin inc(ptCopy); inc(ptAttr); ptCopy^ := ptLine^; end;
					'0': {null}
						if (esNull in Escapes) then begin ptCopy^ := #255; ptAttr^ := #0; end
						else begin inc(ptCopy); inc(ptAttr); ptCopy^ := ptLine^; end;
					else begin
						inc(ptCopy);
						inc(ptAttr);
						{copy char}
						ptCopy^ := ptLine^;
						{mark if #255}
						if ptLine^ = #255
						then ptAttr^ := #255;
					end;
        end; {of case}
      end
			else begin
				{copy char}
				ptCopy^ := ptLine^;
				{mark if #255}
				if ptLine^ = #255
				then ptAttr^ := #255;
			end;
			inc(ptLine);
			inc(ptAttr);
			inc(ptCopy);
    end; {of while}
  	StrCopy(pLine, pCopy);  { copy the amended string back to pLine }
	end; {of if escapes}

	{count of records found}
	aRecordCount := 0;
	{flag to indicate if we are in a string record}
	InQuote := false;
  {flag to indicate we had quote mistake}
	AttachToLast := false;
	{number of characters to examine}
	MaxCount := StrLen(pLine) - 1;
	{first one must start here}
	pStart := Pline;
	{default last character}
  LastChar := #0;
	for Index:= 0 to MaxCount do begin
		{keep status to as to if we are inside delimiter}
		if pLine[index] = Fdelimiter then begin
			{toggle status}
			{make sure its at end of record or next to a separator to end}
			if InQuote then begin
      	if index <= MaxCount - 1 then begin
        	if pLine[index + 1] = Fseparator
					then InQuote := false;
        end
	      else InQuote := false; {EOR}
    	end
    	else begin
				{if it is not just after a separator then it was really the end of}
				{the last string (i.e. string contained "<text>",<text>"}
				if index > 0 then begin
					if LastChar <> Fseparator then begin
						InQuote := false;  {redundent?}
						AttachToLast := true;
  	      end
					else InQuote := true;
				end
				else InQuote := true;
      end;
    end;
		{save last char}
		LastChar := pLine[index];

		{ignore between delimiters}
		if ((not InQuote) and (pLine[index] = Fseparator)) or (index = MaxCount) then begin {force termination}
			{save the end, includes Fseperator}
			if index = MaxCount
			then pEnd := @pLine[index+1] {at #0}
			else pEnd := @pLine[index];

			{terminate it, nuking the Fseperator}
			pEnd^ := #0;

			{save for later}
			ptLine := pEnd + 1;

			{remove pre and post delimiters}
			if pStart^ = Fdelimiter then inc(pStart);
			if (pStart <> pEnd) and ((pEnd - 1)^ = Fdelimiter) then begin
				dec(pEnd);
				pEnd^ := #0;
			end;

			{but escaped characters back}
		  if not (Escapes = []) then begin
				ptAttr := pStart;
   			while ptAttr <= pEnd do begin
					if ptAttr^ = #255
					then ptAttr^ := (pAttr + (ptAttr - PLine))^;
          inc(ptAttr);
				end;
			end;

			fWidth := pEnd - pStart;

			{add it to the list}
			if FillList then begin
				if AttachToLast and (aRecordCount > 0) then begin {this is part of the last field}
					{if it has an object then use it!}
					if List.Objects[aRecordCount-1] <> nil then begin
      			(List.Objects[aRecordCount-1] as TMemoryStream).Write(BinArray,2);
      			(List.Objects[aRecordCount-1] as TMemoryStream).Write(PStart[0],fWidth);
					end
					else begin
						{copy string the hard way}
						s := list.Strings[aRecordCount-1];
						{+ will self terminate at 255}
						for x := 0 to fWidth - 1 do s := s + pStart[x];
						list.Strings[aRecordCount-1] := list.Strings[aRecordCount-1] + '",' + s;
					end;
					AttachToLast := false;
				end
   	  	else begin
					{can't have too many records}
					if aRecordCount >= List.count then exit;
					{if it has an object then use it!}
					if List.Objects[aRecordCount] <> nil then begin
     		  	(List.Objects[aRecordCount] as TMemoryStream).clear;
      			(List.Objects[aRecordCount] as TMemoryStream).Write(PStart[0],fWidth);
         	end
        	else begin
						{copy string the hard way}
						if fWidth > 255 then fWidth := 255;
						for x := 1 to fWidth do s[x] := pStart[x-1];
						s[0] := char(fWidth);
						list.Strings[aRecordCount] := s;
					end;
					inc(aRecordCount);
       	end; {of If Attach..}
      end
 	  	else begin
				if AttachToLast
				then AttachToLast := false
				else inc(aRecordCount);
	    end; {of If Fill..}
 	  	pStart := ptLine;
	  end; {pf If (Not InQuote}
	end; {of for index := ...}

	{fudge:  if we are short record then fake one if last character was a coma}
	if (aRecordCount < List.count) and (lastChar = Fseparator) then inc(aRecordCount);

	{return 1 based count}
	Result := aRecordCount;
finally
	StrDispose(pAttr);
	StrDispose(pCopy);
end;
end; {of parseline}

function Tascii2DB.ParseFixedLine(pLine: Pchar; var list: tstringlist): word;
var
	pTemp, pStart, pEnd: Pchar;
  aRecordCount: word;
  MaxCount: word;
	x: word;
	index: word;
	tChar: char;
	fWidth: word;
	s: string;

function TransposeEscapes(aLine: Pchar): word;
{removes escapes from aLine and return length of new string }
{parsing is fixed width so this type of transposing works   }
{as opposed to the one used in the ParseLine                }
var
	aNew: Pchar;
	aCopy: PChar;
	aCopyStart : Pchar;
begin
	{we have to be careful as once we tranpose #0 we can not use copy
	 so copy first!}

	{crete a temp buffer}
	aCopyStart := StrAlloc(FLineLength + 1); 	{get me a string block}
	{and and index pointer}
	aCopy := aCopyStart;
	{copy string}
	StrCopy(aCopy, aLine);
	{index pointer to new version}
	aNew := aLine;

	while aCopy < StrEnd(aCopy) do begin
		if aCopy^ = '\' then begin
			{default by copying it}
			aNew^ := aCopy^;
			{look a next char}
			inc(aCopy);
			case (aCopy)^ of 
				't': {Horz tab}
							if (esHT in Escapes) then aNew^ := #9
							else begin inc(aNew); aNew^ := aCopy^; end;
				'n': {newline}
							if (esNL in Escapes) then aNew^ := #0
							else begin inc(aNew); aNew^ := aCopy^; end;
				'r': {CR}
							if (esCR in Escapes) then aNew^ := #13
							else begin inc(aNew); aNew^ := aCopy^; end;
				'\': {back slash}
							if (esBSlash in Escapes) then aNew^ := '\'
							else begin inc(aNew); aNew^ := aCopy^; end;
				#34: {double quote}
							if (esDQuote in Escapes) then aNew^ := #34
							else begin inc(aNew); aNew^ := aCopy^; end;
				#39: {single quote}
							if (esSQuote in Escapes) then aNew^ := #39
							else begin inc(aNew); aNew^ := aCopy^; end;
				'?': {question mark}
							if (esQues in Escapes) then aNew^ := '?'
							else begin inc(aNew); aNew^ := aCopy^; end;
				'0': {null}
							if (esNull in Escapes) then aNew^ := #0
							else begin inc(aNew); aNew^ := aCopy^; end;
				{not, so just copy it}
      	else begin 	inc(aNew); aNew^ := aCopy^; end;
			end;
		end
		else aNew^ := aCopy^;
		inc(aCopy);
		inc(aNew);
	end;
	{terminiate it but it should not be needed}
	aNew^ := #0;
	result := aNew - aLine;
	StrDispose(aCopyStart);
end;

begin
	{default to error}
	result := 0;
	{abort if 0 length string}
  if Pline[0] = #0  then exit;

	{count of records found}
	aRecordCount := 0;

	{point to start}
	pStart := pLine;
	pEnd := StrEnd(pLine);

	{get each record}
	for index:= 0 to List.Count - 1 do begin
  	{if it has an object then use it!}
		pTemp:= pStart + MyFieldWidths[index];
		{make sure we are not off the end of the array}
		if pTemp > PEnd then pTemp := pEnd;
		{save character}
   	tChar := pTemp^;
		{terminate it}
		pTemp^ := #0;
		{change escaped characters (aferwards, may contain embedded #0!}
	 	if not (Escapes = [])
		then fWidth := TransposeEscapes(pStart)
		else fWidth := pTemp - PStart;


		{save it}
		if List.Objects[index] <> nil then begin
    	(List.Objects[index] as TMemoryStream).clear;
      (List.Objects[index] as TMemoryStream).Write(pStart[0],fWidth);
    end
		else begin
			{copy string the hard way}
			if fWidth > 255 then fWidth := 255;
			for x := 1 to fWidth do s[x] := pStart[x-1];
			s[0] := char(fWidth);
			list.Strings[index] := s;
		end;
		{restore character}
		pTemp^ := tChar;
		{move pointer}
		pStart := pTemp;
		{ok we got one}
		inc(aRecordCount);
  end;
  {return 1 based count}
	Result := aRecordCount;
end;

function Tascii2DB.GetLine(var F: file; var Line: Pchar): boolean;
{get a line. Line must point to a long enough buffer! (FLineLength + 1)}
{looks for LF and remove CR so it will read UNIX files}
var
	Rfound: word;
	EOR: Pchar;
	Rlen: word;
	Records: word;
	ReadBuf: pchar;
	LF: Pchar;
begin
	{default result}
	Result := false;
	{create a read buffer}
	ReadBuf := StrAlloc(FLineLength + 1);
	{clear strings}
	ReadBuf[0] := #0;
  Line[0] := #0;
	{read block}
	BlockRead(F, readbuf[0], FLineLength ,Rfound);
	{terminate it}
	ReadBuf[Rfound] := #0;
	{find LF (if any)}
	EOR := StrScan(ReadBuf, FEndOfRecord);
	if EOR <> nil then begin
		Rlen := EOR - @ReadBuf[0];
		{replace LF with #0}
		EOR^ := #0;
		{remove cr}
		if FEndOfRecord = #10 then begin
			{remove #13 if just prior}
			if (EOR-1)^ = #13
			then (EOR-1)^ := #0;
			StrCopy(Line,ReadBuf);
			end
		else begin
			{remove any #10, #13 if #10 is not EOR for multiline records}
			while true do begin
				LF := StrScan(ReadBuf, #10);
				if LF = nil then begin
					StrCat(Line, ReadBuf);
					break;
        end;
				LF^ := #0;
				if (LF - 1)^ = #13
				then (LF - 1)^ := #0;
				StrCat(Line, ReadBuf);
        ReadBuf := LF + 1;
			end;
		end;
		{put file pointer just after EOR}
		Seek(F,FilePos(F) - RFound + Rlen + 1);
		Result := True;
  end
  else begin  {not LF found, check of odd terminated files}
		if not eof(F) then begin {line is long!}
			Line^ := #0; {clear it}
		end
		else begin
    	{kill eof marker and return what is left}
	    {in case last EndOfRecord does not exist}
			if ReadBuf[Rfound-1] = #26 then begin
				ReadBuf[Rfound-1] := #0;
				{remove cr}
				if FEndOfRecord = #10 then begin
					if ReadBuf[Rfound-2] = #13
					then ReadBuf[Rfound-2] := #0;
				end;
      end
			else begin
				{remove cr}
				if FEndOfRecord = #10 then begin
					if ReadBuf[Rfound-1] = #13
					then ReadBuf[Rfound-1] := #0;
				end;
			end;
			StrCopy(Line,ReadBuf);
			Result := True;
    end;
  end;
	StrDispose(ReadBuf);
end; {of GetLine}

function Alltrim(S: String): string;
var
	x: integer;
begin
	{remove trailing spaces}
  x := Length(S);
	if x = 0 then begin
		Result := S;
		exit;
		end;
	while S[x] = ' ' do begin
		dec(x);
		S[0] := char(x);
		end;
	{leading spaces}
	for x := 1 to Length(S) do
  	if S[x] <> ' ' then break;
	if x > 1 then delete(S,1,x);

	Result := S;
end;

procedure Register;
begin
  RegisterComponents('Fitco', [Tascii2DB]);
end; {of register}

end. {of unit}


