unit Udemo;
{ David Berneda 100115,1155@compuserve.com }
{ Look at this source code to learn to use TRemoteQuery }

{ note that most of this code is only for demo purposes,
  the only interesting source line is the TRemoteQuery.Open; !!!
}
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons, DBCtrls, Grids, DBGrids, DB,
  UTqbe, DBTables;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    BitBtn1: TBitBtn;
    Label3: TLabel;
    Panel2: TPanel;
    Label4: TLabel;
    Table1: TTable;
    Button1: TButton;
    Timer1: TTimer;
    BitBtn2: TBitBtn;
    Table1NumeroConsulta: TIntegerField;
    Table1Fecha: TDateField;
    Table1Hora: TTimeField;
    Table1Cliente: TStringField;
    Table1Usuario: TStringField;
    Table1TipoConsulta: TStringField;
    Table1Consulta: TMemoField;
    Table1Estado: TStringField;
    Table1Error: TStringField;
    Panel3: TPanel;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    BitBtn3: TBitBtn;
    RadioGroup1: TRadioGroup;
    RemoteQuery1: TRemoteQuery;
    Memo1: TMemo;
    Database1: TDatabase;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure RemoteQuery1Waiting(Sender: TObject; what: TRemoteStatus);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure AppException(Sender: TObject; E:Exception);
    procedure RefreshServerAlias;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
Uses dbiTypes; { this is needed to switch between QBE & SQL }

{ All this stuff is only for this demo !!! }
procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnException:=AppException;
  RemoteQuery1.DoRemote:=True;
  CheckBox1.Checked:=False;
  Session.GetAliasNames(ComboBox1.Items);
  RefreshServerAlias;
  RadioGroup1Click(Self);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  BitBtn1.Enabled:=False; { dont let to push button !!! }
  BitBtn2.Enabled:=True;
  ComboBox1.Enabled:=False;
  Panel2.Color:=clBtnFace; { reset blinking panel color }
  Panel3.Color:=clBtnFace; { reset blinking panel color }
  Label3.Caption:='Starting...';
  Application.ProcessMessages; { to allow label repaint }
  try
    With RemoteQuery1 do
    Begin
      Close;
      QBE.Assign(Memo1.Lines); { this allows user to change query statement }
      Open; { <-------- Here comes the magic !!!  }
    End;
  finally
    BitBtn1.Enabled:=True; { reset button and blinking panel color... }
    BitBtn2.Enabled:=False;
    Panel2.Color:=clBtnFace;
    Panel3.Color:=clBtnFace;
    ComboBox1.Enabled:=True;
  end;
end;

{ Show on screen the remote query execution status ... }
procedure TForm1.RemoteQuery1Waiting(Sender: TObject; what: TRemoteStatus);
begin
  With Label3 do
  Case what of
    rsStart           : Caption:='Starting...';
    rsWaitingBegin    : Caption:='Waiting Begin...';
    rsWaitingExecution: Caption:='Waiting Execution...';
    rsOK              : Caption:='OK !!!';
    rsError           : Caption:='Error !!!';
    rsTimeout         : Caption:='Timeout !!!';
    rsIdle            : if Panel2.Color=clBlue then Panel2.Color:=clRed
                                               else Panel2.Color:=clBlue;
    rsRefreshing      : if Panel3.Color=clGreen then Panel3.Color:=clYellow
                                                else Panel3.Color:=clGreen;
    rsCancel          : Caption:='Aborted !!';
  end;
  Application.ProcessMessages; { give time to repaint label !!!  }
end;

{ change dbGrid to show query results or remote query queue... }
procedure TForm1.Button1Click(Sender: TObject);
begin
  if DataSource1.DataSet=Table1 then
  Begin
    DataSource1.DataSet:=RemoteQuery1;
    Button1.Caption:='&See Queue';
  end
  else
  begin
    DataSource1.DataSet:=Table1;
    Button1.Caption:='&Back...';
  end;
end;

{ Cancel Query execution !!! }
procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  RemoteQuery1.Cancel:=True;
end;

{ Change from doing the query remotely or locally }
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  RemoteQuery1.DoRemote:=not CheckBox1.Checked;
end;

{ Try to change targeted Server for query }
procedure TForm1.ComboBox1Change(Sender: TObject);
Var OldAlias:String;
begin
  OldAlias:=RemoteQuery1.ServerAlias;
  Screen.Cursor:=crHourGlass;
  try
    try
      RemoteQuery1.ServerAlias:=ComboBox1.Items[ComboBox1.ItemIndex];
      RefreshServerAlias;
    except
      on Exception do
      Begin
        RemoteQuery1.ServerAlias:=OldAlias;
        RefreshServerAlias;
        Raise;
      end;
    end;
  finally
    Screen.Cursor:=crDefault;
  end;
end;

{ Small routine to show exceptions with more details when debugging }
procedure TForm1.AppException(Sender: TObject; e:Exception);
begin
{$IFOPT D+}
  SysUtils.ShowException(E,ExceptADDR);
{$ELSE}
  Application.ShowException(E);
{$ENDIF}
end;

{ Paint correct Server Alias and Path }
procedure TForm1.RefreshServerAlias;
Begin
  ComboBox1.ItemIndex:=ComboBox1.Items.IndexOf(RemoteQuery1.ServerAlias);
  With Table1 do
  Begin
    Close;
    DatabaseName:=RemoteQuery1.ServerAlias;
    Open;
  end;
  Label2.Caption:=GetAliasPath(RemoteQuery1.ServerAlias);
End;

{ refresh pending query queue }
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if DataSource1.DataSet=Table1 then
  With Table1 do
  Begin
    Refresh;
    Last;
  end;
end;

{ Switch between QBE and SQL query languages }
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  { this is for this demo only... }
  With RemoteQuery1 do
  Case RadioGroup1.ItemIndex of
    0: Begin
         QBE.Clear;
         QBE.Add(':dbdemos:customer.db | CustNo | Company   |');
         QBE.Add('                     | Check  | Check A.. |');
         QueryLang:=QryLangQBE;
       End;
    1: Begin
         QBE.Clear;
         QBE.Add('select CustNo,Company from ":dbdemos:customer.db" ');
         QBE.Add('where Company>"A" and Company<"B"');
         QueryLang:=QryLangSQL; { that's the trick to do SQL !!! }
       End;
  End;
  Memo1.Lines.Assign(RemoteQuery1.QBE); { to show the query on-screen }
end;

end.
