unit AmlAbout;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms,
     Controls, StdCtrls, Buttons, ExtCtrls, SysUtils,
     LicEng, LicIta;

type
  TAmlAboutBox = class(TForm)
    Panel1: TPanel;
    ProgramIcon: TImage;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Comments: TLabel;
    AuthorBox: TGroupBox;
    NameLabel: TLabel;
    AddressLabel: TLabel;
    ZIPLabel: TLabel;
    PhoneLabel: TLabel;
    OkBtn: TBitBtn;
    LicenseBtn: TBitBtn;
    procedure LicenseBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


function ShowAmlAboutBox(
          aProduct: PChar;
          aVersion: PChar;
          aCopyRight :PChar;
          aComments: PChar;
          aCountry: integer): integer; export;

implementation

{$R *.DFM}
var
  CountryCode: integer;

function ShowAmlAboutBox(
          aProduct:   PChar;
          aVersion:   PChar;
          aCopyright: PChar;
          aComments:  PChar;
          aCountry:   integer): integer;
var
  AmlAboutBox: TAmlAboutBox;
begin
  Result := mrCancel;
  CountryCode := aCountry;
  AmlAboutBox := TAmlAboutBox.Create(Application);
  try
    with AmlAboutBox do begin
      ProductName.Caption   := StrPas (aProduct);
      if ProductName.Caption = '' then
        ProductName.Caption := 'AmlSoft EasyWare';
      Copyright.Caption := 'Copyright ' + StrPas (aCopyright);
      Comments.Caption  := StrPas (aComments);
      case aCountry of
        39: begin {Italiano}
          Caption := 'Info su ' + ProductName.Caption;
          Version.Caption    := 'Versione ' + StrPas (aVersion);
          LicenseBtn.Caption := '&Licenza';
          if Comments.Caption = '' then
            Comments.Caption := 'Uso e distribuzione liberi. Clicca sul bottone &Licenza per le Condizioni di Licenza';
        end;
        else
        begin {Inglese}
          Caption := 'About ' + ProductName.Caption;
          LicenseBtn.Caption := '&License';
          Version.Caption    := 'Version ' + StrPas (aVersion);
          if Comments.Caption = '' then
            Comments.Caption := 'Free use and distribtion. Click on &License button for License Agreement';
        end;
      end; {case}
      Result := ShowModal;
    end; {with}
  finally
    AmlAboutBox.Free;
  end;
end;

procedure TAmlAboutBox.LicenseBtnClick(Sender: TObject);
var
  LicenseBox: TLicenseBoxEng;
begin
  case CountryCode of
    39: LicenseBox := TLicenseBoxIta.Create(Application);
    else LicenseBox := TLicenseBoxEng.Create(Application);
  end;
  try
    LicenseBox.ShowModal;
  finally
    LicenseBox.Free;
  end;
end;

end.

