Library Remodll;

Uses Dialogs,
  Forms,
  SysUtils,
  UTQBE,
  dbiTypes,
  Uremodlg in 'UREMODLG.PAS' {RemoteDlg};

{ Parameters:
     WantDialog : Longint (0 means NO, 1 means YES)
     Query      : PChar   (name of query file with extension QBE or SQL)
     ParamName  : PChar   (One param. ie: today)
     ParamValue : PChar   (Value of param. ie: >=7/1/95,<=7/31/95)
}

{ Use Example:
    RemoteQuery(1,'myquery.qbe','today','>=7/1/95');

  Return values:
    0    :   OK !!!
    1    :   ERROR !!!
    2    :   USER HAS CANCELED !!!
}
Function RemoteQuery(WantDialog:Longint; Query,ParamName,ParamValue:PChar):Longint; export;
var t:TRemoteQuery;
    f:TRemoteDlg;
    ext:String;
Begin
  result:=1;
  if WantDialog<>0 then f:=TRemoteDlg.Create(Application)
                   else f:=nil;
  try
    if Assigned(f) then f.Caption:='Executing...';
    try
      t:=TRemoteQuery.Create(Application);
      with t do
      try
        SecondsTimeout:=600;
        if Assigned(f) then f.TheQuery:=t;
        ClearParams;
        AddParam(StrPas(ParamName),StrPas(ParamValue));
        QBE.LoadFromFile(StrPas(Query));
        AskMoreWait:=True;
        Ext:=Uppercase(ExtractFileExt(StrPas(Query)));
        Ext:=Copy(Ext,Length(Ext)-2,3);
        if Ext='QBE' then
        Begin
          QueryLang:=qryLangQBE;
          AnswerTable:=GetAnswerName;
          if AnswerTable='' then
             raise Exception.Create('Cannot guess answer table name.');
        end
        else
        if Ext='SQL' then
        Begin
          AnswerTable:='';
          QueryLang:=qryLangSQL;
        end
        else
         raise Exception.Create('Invalid query file extension. (Must be QBE or SQL)');
        if Assigned(f) then f.Show;
        Open;
        if Assigned(f) then f.Close;
        result:=0;
      Finally
        Free;
      end;
    except
      on E:Exception do
        if E is EAbort then result:=2
                       else ShowException(E,nil);
    end;
  finally
    if Assigned(f) then f.Free;
  end;
End;

exports RemoteQuery index 1;
Begin
end.
