{+}
{ Aml Bmp Selector
{  1996, Amedeo Lanza - Torino, Italy
{ amldc@mbox.vol.it
{
{ original idea and code portions
{  1995, Daniel Parnell - Melbourne, Australia
{ s921878@minyos.xx.rmit.edu.au
{
{---------}
{ History
{ V 1.1 - Removed use of AmlSoft DLL library
{         Removed unused reference to Elastic unit
{         Added release of Buttons Palette on exit
{         Added Clear button
{ V 1.0 - First release
{
{-}
unit BmpSel;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, AtAbout, ExtCtrls, StdCtrls, FileCtrl,
  BtnWin,AddDir,IniFiles, Menus;

type
  TAmlBmpSelector = class(TForm)
    SpeedPanel: TPanel;
    SBtnInfo: TSpeedButton;
    SBtnExit: TSpeedButton;
    StatusPanel: TPanel;
    LeftPanel: TPanel;
    DirPanel: TPanel;
    DirectoryListBox: TDirectoryListBox;
    DriveComboBox: TDriveComboBox;
    FileListBox: TFileListBox;
    FileEdit: TEdit;
    DirHistory: TComboBox;
    ButtonsPanel: TPanel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    StatusDirPanel: TPanel;
    Directorylabel: TLabel;
    Label1: TLabel;
    StatusSizePanel: TPanel;
    Label2: TLabel;
    ImageSizeLabel: TLabel;
    RightPanel: TPanel;
    ImagePanel: TPanel;
    ExamplesPanel: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    BtnLabel1: TLabel;
    BtnLabel2: TLabel;
    BtnLabel3: TLabel;
    GlyphsComboBox: TComboBox;
    GlyphsLabel: TLabel;
    StretchCheckBox: TCheckBox;
    ScrollBox1: TScrollBox;
    Image: TImage;
    FilterComboBox: TFilterComboBox;
    SBtnAddDir: TSpeedButton;
    ShowButtonsCheckBox: TCheckBox;
    ButtonPaletteCheckBox: TCheckBox;
    SpeedButton4: TSpeedButton;
    BmpDirListMenu: TPopupMenu;
    AddDirItem: TMenuItem;
    RemoveDirItem: TMenuItem;
    FilterLabel: TLabel;
    DriveLabel: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    ClearBtn: TBitBtn;
    procedure SBtnInfoClick(Sender: TObject);
    procedure SBtnExitClick(Sender: TObject);
    procedure DirPanelResize(Sender: TObject);
    procedure RightPanelResize(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FileListBoxChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure StretchCheckBoxClick(Sender: TObject);
    procedure SBtnAddDirClick(Sender: TObject);
    procedure SBtnRemoveDirClick(Sender: TObject);
    procedure ShowButtonsCheckBoxClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonPaletteCheckBoxClick(Sender: TObject);
    procedure DirHistoryChange(Sender: TObject);
    procedure DirectoryListBoxChange(Sender: TObject);
    procedure GlyphsComboBoxChange(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
  private
    { Private declarations }
    BmpDirList :TStringList;
    procedure AddDirectory(s : string);
    procedure SetButtonsText;
  public
    { Public declarations }
  end;

var
  AmlBmpSelector: TAmlBmpSelector;

implementation

{$R *.DFM}

procedure TAmlBmpSelector.SBtnInfoClick(Sender: TObject);
begin
  AmlTabbedAbout := TAmlTabbedAbout.Create(Application);
  try
    AmlTabbedAbout.ShowModal;;
  finally
    AmlTabbedAbout.Free;
  end;

end;

procedure TAmlBmpSelector.SBtnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TAmlBmpSelector.DirPanelResize(Sender: TObject);
begin
  FileListBox.Height := DirPanel.Height - 100;
  FilterLabel.Top := DirPanel.Height - 45;
  FilterComboBox.Top := DirPanel.Height - 29;
  DirectoryListBox.Height := DirPanel.Height - 100;
  DriveLabel.Top := DirPanel.Height - 45;
  DriveComboBox.Top := DirPanel.Height - 29;
end;

procedure TAmlBmpSelector.RightPanelResize(Sender: TObject);
begin
{  ImagePanel.Height := (RightPanel.Height - GlyphsPanel.Height) div 2}
end;

procedure TAmlBmpSelector.FormResize(Sender: TObject);
begin
  if Width < 474 then Width := 474;
  if Height < 245 then Height := 245;
end;

procedure TAmlBmpSelector.AddDirectory(s : string);
begin
  DirHistory.items.add(copy(s,1,pos('=',s)-1));
end;

procedure TAmlBmpSelector.SetButtonsText;
begin
  if SpeedButton1.Down then
  begin
    BtnLabel1.Caption := 'Down';
    SpeedButton1.Hint := 'Down button example';
    BtnLabel2.Caption := 'Up';
    SpeedButton2.Hint := 'Up button example';
  end
  else
  begin
    BtnLabel1.Caption := 'Up';
    SpeedButton1.Hint := 'Up button example';
    BtnLabel2.Caption := 'Down';
    SpeedButton2.Hint := 'Down button example';
  end;
end;

procedure TAmlBmpSelector.FileListBoxChange(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  try
    if FileExists(FileListBox.FileName) then
    with Image.Picture do
    begin
      Image.Picture.LoadFromFile(FileListBox.FileName);
      ScrollBox1.HorzScrollBar.Range:= Width;
      ScrollBox1.VertScrollBar.Range:= Height;
      ScrollBox1.HorzScrollBar.Position:=0;
      ScrollBox1.VertScrollBar.Position:=0;
      ImageSizeLabel.Caption := Format ('%dx%d',[Width,Height]);
      if ShowButtonsCheckBox.Checked then
      begin
        SpeedButton1.Glyph := Bitmap;
        SpeedButton2.Glyph := Bitmap;
        SpeedButton3.Glyph := Bitmap;
        SetButtonsText;
        GlyphsComboBox.Text := IntToStr(SpeedButton1.NumGlyphs);
      end;

      if image.picture.bitmap<>nil then
        if image.picture.bitmap.empty then
          ClearBtn.Enabled:=FALSE
        else
          ClearBtn.Enabled:=TRUE;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TAmlBmpSelector.SpeedButton1Click(Sender: TObject);
begin
  SetButtonsText;
end;

procedure TAmlBmpSelector.SpeedButton2Click(Sender: TObject);
begin
  SetButtonsText;
end;

procedure TAmlBmpSelector.SBtnAddDirClick(Sender: TObject);
begin
  AddDirDlg:=TAddDirDlg.Create(Application);
  try
    AddDirDlg.Directory.Text := DirectoryListBox.Directory;
    AddDirDlg.DirName.Clear;
    if AddDirDlg.ShowModal=mrOK then
      begin
        BmpDirList.Values[AddDirDlg.DirName.Text] := AddDirDlg.Directory.Text;
        AddDirectory(BmpDirList.Strings[BmpDirList.Count-1]);
        DirHistory.ItemIndex:=BmpDirList.Count-1;
      end;
  finally
    AddDirDlg.Free;
  end;
end;

procedure TAmlBmpSelector.SBtnRemoveDirClick(Sender: TObject);
begin
  DirHistory.Items.Delete(DirHistory.ItemIndex);
end;

procedure TAmlBmpSelector.DirHistoryChange(Sender: TObject);
begin
  if DirHistory.text<>'' then
    DirectoryListbox.Directory:=BmpDirList.Values[DirHistory.Text];
end;

procedure TAmlBmpSelector.ButtonPaletteCheckBoxClick(Sender: TObject);
begin
  if ButtonPaletteCheckBox.Checked then
  begin
    Screen.Cursor := crHourGlass;
    try
      ButtonsForm := TButtonsForm.Create(Application);
      ButtonsForm.Show;
      ButtonsForm.CreateButtons(FileListBox);
    finally
      Screen.Cursor := crDefault;
    end;
  end
  else
  begin
    ButtonsForm.Free;
    ButtonsForm := nil;
  end;
end;

procedure TAmlBmpSelector.StretchCheckBoxClick(Sender: TObject);
begin
  Image.Stretch := StretchCheckBox.Checked;
end;

procedure TAmlBmpSelector.ShowButtonsCheckBoxClick(Sender: TObject);
var TmpBmp :TBitmap;
begin
  ExamplesPanel.Visible := ShowButtonsCheckBox.Checked;
  if ShowButtonsCheckBox.Checked then
    with Image.Picture do
    begin
      SpeedButton1.Glyph := Bitmap;
      SpeedButton2.Glyph := Bitmap;
      SpeedButton3.Glyph := Bitmap;
      SetButtonsText;
      GlyphsComboBox.Enabled := true;
      GlyphsLabel.Enabled := true;
      GlyphsComboBox.Text := IntToStr(SpeedButton1.NumGlyphs);
    end
  else
  begin
    TmpBmp := TBitmap.Create;
    try
      SpeedButton1.Glyph.Assign(TmpBmp);
      SpeedButton2.Glyph.Assign(TmpBmp);
      SpeedButton3.Glyph.Assign(TmpBmp);
      GlyphsCombobox.Text := ' ';
      GlyphsComboBox.Enabled := false;
      GlyphsLabel.Enabled := false;
    finally
      TmpBmp.Free;
    end;
  end;
end;

procedure TAmlBmpSelector.FormCreate(Sender: TObject);
var
  DelphiIni : TIniFile;
begin
  BmpDirList := TStringList.Create;
  DelphiIni  := TIniFile.Create('delphi.ini');
  DelphiIni.ReadSectionValues('AmlBmpSelector.DirList', BmpDirList);
  DelphiIni.Free;
end;

procedure TAmlBmpSelector.FormClose(Sender: TObject; var Action: TCloseAction);
var
  DelphiIni : TIniFile;
  i         : integer;
begin
  DelphiIni := TIniFile.Create('delphi.ini');
  DelphiIni.EraseSection('AmlBmpSelector.DirList');
  for i:=0 to BmpDirList.count-1 do
    DelphiIni.WriteString('AmlBmpSelector.DirList',
                          DirHistory.items.Strings[i],
                          BmpDirList.values[DirHistory.Items.Strings[i]]);
  DelphiIni.Free;
end;

procedure TAmlBmpSelector.FormDestroy(Sender: TObject);
begin
  BmpDirList.Free;
  if ButtonPaletteCheckBox.Checked then
  begin
    ButtonsForm.Free; {run from Delphi IDE will raise an EGPF exception}
    ButtonsForm := nil;
  end;
end;

procedure TAmlBmpSelector.FormShow(Sender: TObject);
var
  i : integer;
begin
  DirHistory.Clear;
  for i:=0 to BmpDirList.Count-1 do
    AddDirectory(BmpDirList.Strings[i]);
  if BmpDirList.Count<>0 then
  begin
    DirHistory.ItemIndex:=0;
    if DirHistory.Text<>'' then
      DirectoryListbox.Directory:=BmpDirList.Values[DirHistory.Text];
  end;
end;

procedure TAmlBmpSelector.DirectoryListBoxChange(Sender: TObject);
begin
  if ButtonPaletteCheckBox.Checked then
  begin
    ButtonsForm.ClearButtons;
    ButtonsForm.CreateButtons(FileListBox);
  end;
end;

procedure TAmlBmpSelector.GlyphsComboBoxChange(Sender: TObject);
var n :byte;
begin
  n := GlyphsComboBox.ItemIndex +1;
  SpeedButton1.NumGlyphs := n;
  SpeedButton2.NumGlyphs := n;
  SpeedButton3.NumGlyphs := n;
end;

procedure TAmlBmpSelector.ClearBtnClick(Sender: TObject);
var
  Temp :TBitmap;
begin
  if Image.Picture.Bitmap<>nil then
    begin
      temp:=TBitmap.Create;
      image.picture.bitmap.assign(temp);
      temp.free;
      ClearBtn.Enabled:=FALSE;
    end;

end;

end.
