(* Copyright (c) 1995 Hyper Logic Resource Group
 Compuserve 72700,2407 Internet sgarland@micron.net

 I got sick and tired of trying to figure out those crazy, detailed
 variables needed for those low level Idapi calls. So I just created
 a descendant of TTable so I could look at the field names and types.

 Set the BDEInfo Property to BDENOInfo and it acts just like a TTable.
 But if you set the other values you get some examples of the In memory
 tables that the BDE can return. I didn't do them all as I haven't used
 such famous hits as DBIOpenLockList or dBIOpenRintList. But I'm sure
 you can just bolt them in there and they will work just fine.

 This is Freeware so use at your own risk. If you figure out some
 cool enhancement please let me know.

 Steve Garland
 Boise, Idaho
 12 December 1995 *)

unit Hbdeinfo;

interface
uses dbitypes,SysUtils,dbTables,classes,db;

Type
 BDEInfoType=(BdeNOInfo,BDEUserInfo,BDEFieldInfo,BDEIndexInfo,BDEOpenTAbles);
 TBDEInfoTable=Class(TTable)
  Private
   FBDEInfo:BDEInfoType;
   protected
    function CreateHandle: HDBICur; override;
   published
   property BDEInfo:BDEInfoType read FBDEInfo write FBDEInfo default BDENoInfo;
end;
Procedure Register;

implementation
uses dbiprocs,wintypes,DSgnIntf;

type
 IdapiUtil=class
    DBName:pchar;
    hdb : hDBIDb;{Handle to the database.}
  public
  constructor init(DataBaseName:String);
  destructor destroy;override;
  Function OpenTablesCursor(Mask:PChar):HDBICur;
  Function FieldAsCursor(Tablename:string):HDbiCur;
  Function IndexListAsCursor(Tablename:string):HDbiCur;
end;

constructor IdapiUtil.init(DataBaseName:String);
begin
 inherited create;
 getmem(dbname,length(databasename)+1);
 strpcopy(dbname,databasename);
 DbiOpenDatabase(dbName, nil, dbiREADONLY, dbiOPENEXCL,nil, 0, nil, nil, hDb);
end;

destructor IdapiUtil.destroy;
begin
 freemem(dbName,strlen(dbname)+1);
 if hdb<>nil then DbiCloseDatabase(hDb);
 inherited destroy;
end;

Function IdapiUtil.OpenTablesCursor(Mask:Pchar):HDBICur;
begin
try
 DbiOpenTableList(hDb,FALSE,FALSE,MASK,result);
 except;
end;
end;

Function IdapiUtil.IndexListAsCursor(Tablename:string):HDbiCur;
var
tname:array[0..60] of char;
begin
result:=nil;
strpcopy(tname,tablename);
try
 DbiOpenIndexList(hDb,tname,szparadox,Result);
 except;
end;
end;


Function IdapiUtil.FieldAsCursor(Tablename:string):HDbiCur;
var
tname:array[0..60] of char;
begin
result:=nil;
strpcopy(tname,tablename);
try
 DbiOpenFieldList(hDb,tname,szparadox,False,result);
 except;
end;
end;

Function IdapiUtilAsTable(Alias,Tablename:String;InfoType:BDEInfoType):HDbiCUR;
var
idapi:IDapiutil;
begin
 Result:=nil;
 Idapi:=IDapiUtil.Init(Alias);
 Case InfoType of
  BDEFieldInfo :Result:=Idapi.FieldAsCursor(Tablename);
  BDEIndexInfo :Result:=Idapi.IndexListAsCursor(TableName);
  BdeOpenTables:Result:=Idapi.OpenTablesCursor('*');
 end;
 Idapi.Free;
end;
Function UsersListAsCursor:HDBICur;
begin
 DbiOpenUserList(result);
end;

function TBDEInfoTable.CreateHandle: HDBICur;
begin
 result:=nil;
 case FBDEInfo of
  BDEUserInfo     :Result:=UsersListAsCursor;
  BDEFieldInfo..
   BDEOpenTAbles  :REsult:=IdapiUtilAsTable(DatabaseName,Tablename,FBDEInfo);
  Else Result:=inherited CreateHandle;
 end;
end;


Procedure Register;
begin
RegisterComponents('Hyper Logic',[TBDEInfoTable]);
end;

end.
