{ JAboutE.Pas -
  James' About Property Editor v1.00 by James Hargrave (hargrave@mep.com)
                                        Vancouver, BC
                                        Canada
  ---------------------------------------------------------------------------
  Copyright 1995 by Minds Edge Productions Inc. (info@mep.com)
  ---------------------------------------------------------------------------
   This file is freeware.  Do whatever you'd like with it the author(s) take
   no responsibility.  But please give credit to Martyn Dowsett (the origional
   author) and James Hargrave (modifications explained bellow) when and where
   it is due.
  ---------------------------------------------------------------------------
   This file contains the source code to the property editor that
   displays the about box when the about property of the VCL is
   clicked on.  The code is based on ABOUT.PAS by Martyn
   Dowsett (CompuServe ID 100676,1560) who's source code has
   helped me alot. I'd like to give Martyn a huge thanks for his
   support and for releasing his source code (actually I'd like to
   thank everyone that releases their source).
  ---------------------------------------------------------------------------
   The following modifications were made to Martyn's code:

   Removed the $R *.DMF so no .DMF files need to be included
   in the distribution of the about box editor, instead the about
   box is now stored in a .DLL file (See AboutDll.DPR and associated .PAS
   files). The reason I did this is because I was looking for a way to
   distribute a VCL with an about box that couldn't be changed easilly.

   There are three ways that I currently can think of to display
   an about box with this about property editor:

   1) Display an about form (As in the origionaly source code)
      Advantage: Easy to implement.
      Disadvantage: It's easy for someone to change your about box.
      Files you would need to distribute:
      The .DCU (compiled .PAS) and the .DFM of the about form.

   2) Display a message box.
      Advantage: Hard to change, Small distribution size.
      Disadvantage: The about box doesn't look very good.
      Files you would need to distribute:
      Just the .DCU (compiled .PAS).

   3) Display a form in a .DLL. (This is the way it is implemented here)
      Advantage: Larger distirubtion size.
      Disadvantage: A tiny bit harder to implement.
      Files you would need to distribute:
      The .DCU (compiled .PAS) and the .DLL
      (note: The .DLL is only needed by the developer using
             your VCL, not by any programs compiled with your VLC)

  ---------------------------------------------------------------------------
}

unit JAboutE; {James' About Property Editor}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons, DsgnIntf;

type
	TAboutBoxObject = class(TObject)
	end;

	TAboutBoxEditor = class(TPropertyEditor)
		function GetAttributes: TPropertyAttributes; override;
		function GetValue: string; override;
		procedure Edit; override;
	end;

implementation

{Import the interface routine for the about form}
procedure ShowAboutVCLDlg; far; external 'ABOUTDLL';

{---------------------------------------------------------------}

function TAboutBoxEditor.GetAttributes;
begin
	Result := inherited GetAttributes +
				[paDialog]+[paReadOnly];
end;

{---------------------------------------------------------------}

function TAboutBoxEditor.GetValue: string;
begin
	{This is the caption displayed in the Object Inspector}
	Result := 'Click on...for About box';
end;

{----------------------------------------------------------------}

Procedure TAboutBoxEditor.Edit;
Begin
  {Call the form stored in ABOUTDLL.DLL (See ABOUTDLL.DPR and
   associated .PAS files}
  ShowAboutVCLDlg;
End;

{---------------------------------------------------------------}

end.
