unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, FileCtrl, Grids, Outline, DirOutln,
  ExtCtrls, Menus, Status, Bitcon10, About;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    DirectoryOutline1: TDirectoryOutline;
    DLFStatusBar1: TDLFStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    DLFBitCon1: TDLFBitCon;
    View1: TMenuItem;
    procedure DirectoryOutline1Change(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure DirectoryOutline1DragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure DirectoryOutline1DragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure Exit1Click(Sender: TObject);
    procedure DLFBitCon1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure View1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.DirectoryOutline1Change(Sender: TObject);
begin
     DLFBitCon1.Directory:=DirectoryOutline1.Directory;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
    DLFBitCon1.Columns:= DLFBitCon1.Width div 135;
end;

procedure TForm1.DirectoryOutline1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
     accept:= Source is TDLFBitCon;
end;

procedure TForm1.DirectoryOutline1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
I,Old:Integer;
FromFile, ToFile, Filename:String;
begin
    Old:=DirectoryOutline1.SelectedItem;
    I:=DirectoryOutline1.GetItem(X,Y);
    FromFile:=DLFBitCon1.Directory + '\'+DLFBitCon1.Items[DLFBitCon1.ItemIndex];
    FileName:=DLFBitCon1.Items[DLFBitCon1.ItemIndex];
    DirectoryOutline1.SelectedItem:=I;
    ToFile:=DirectoryOutline1.Directory+ '\'+Filename;
    DLFBitCon1.CopyPicture(FromFile,ToFile);
    DirectoryOutline1.SelectedItem:=Old;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.DLFBitCon1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if (Button = mbRight) then
          DLFBitCon1.ShowPicture
     else
          DLFBitCon1.BeginDrag(False);
end;

procedure TForm1.View1Click(Sender: TObject);
begin
     DLFBitCon1.ShowPicture;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
     AboutBox.ShowModal;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    DLFBitCon1.Columns:= DLFBitCon1.Width div 135;
end;

end.
