unit NewFont;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Spin, ExtCtrls;

type
  TNewFontForm = class(TForm)
    WidthsGroup: TGroupBox;
    SmallWidth: TSpinEdit;
    LargeWidth: TSpinEdit;
    cbProportional: TCheckBox;
    cbNoDefault: TCheckBox;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    procedure cbProportionalClick(Sender: TObject);
    procedure ShowWidthEnabling(Sender:TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  NewFontForm: TNewFontForm;

implementation

{$R *.DFM}

{ Following is called by Form.OnActivate and cbNoDefault.OnClick }
procedure TNewFontForm.ShowWidthEnabling(Sender:TObject);
const
  TEditColors:array[False..True] of TColor = (clBtnFace,clWindow);
var
  WidEnable:boolean;
begin
  WidEnable := not (cbProportional.Checked and cbNoDefault.Checked);
  SmallWidth.Enabled := WidEnable;
  LargeWidth.Enabled := WidEnable;
  SmallWidth.Color := TEditColors[WidEnable];
  LargeWidth.Color := TEditColors[WidEnable];
  cbNoDefault.Enabled := cbProportional.Checked;
end;

procedure TNewFontForm.cbProportionalClick(Sender: TObject);
begin
  if cbProportional.Checked
    then WidthsGroup.Caption := 'Default widths'
    else WidthsGroup.Caption := 'Widths';
  ShowWidthEnabling(Sender);
end;

end.
