unit Preview;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons;

type
  TPreviewForm = class(TForm)
    bbOptions: TBitBtn;
    bbSave: TBitBtn;
    bbClose: TBitBtn;
    Memo: TMemo;
    SaveDialog: TSaveDialog;
    lModified: TLabel;
    procedure bbSaveClick(Sender: TObject);
    procedure bbOptionsClick(Sender: TObject);
    procedure MemoChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PreviewForm: TPreviewForm;

implementation
uses Options,Main;
{$R *.DFM}

procedure TPreviewForm.bbSaveClick(Sender: TObject);
begin
  if SaveDialog.Execute then
    begin
      Memo.Lines.SaveToFile(SaveDialog.FileName);
      Close;
    end;
end;

procedure TPreviewForm.bbOptionsClick(Sender: TObject);
begin
  OptionsDlg.ShowModal;
  try
    Memo.Lines.BeginUpdate;
    FontEditorForm.Generate;
  finally
    Memo.Lines.EndUpdate;
    MemoChange(Sender);
  end;
end;

procedure TPreviewForm.MemoChange(Sender: TObject);
begin
  lModified.Visible := Memo.Modified;
end;

procedure TPreviewForm.FormActivate(Sender: TObject);
begin
  MemoChange(Sender);
end;

end.
