{
 Designer:  Craig Ward
 Date:      18/1/96

 Version:   1.0

 Function:  Filter box (allows user to set filter on records to be printed).
********************************************************************************}
unit Query;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, DB, DBTables, Print, Spin, Cwlist;

type
  TQueryDlg = class(TForm)
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Label4: TLabel;
    Bevel3: TBevel;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    queryPrint: TQuery;
    Label1: TLabel;
    Bevel4: TBevel;
    SpinEdit1: TSpinEdit;
    Label2: TLabel;
    SpeedButton3: TSpeedButton;
    lstFields: TcwListBox;
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
  private
    { Private declarations }
    FTable: string;                                               {stores table name}
    procedure SetList;
    procedure SetQuery;
  public
    { Public declarations }
    FSQL: string;
    FSQLWhereClause: TStringList;
  end;

var
  QueryDlg: TQueryDlg;

implementation

{$R *.DFM}

uses
 Filter;


{***custom routines*************************************************************}

{set list}
procedure TQueryDlg.SetList;
var
 iInc: integer;
begin

 lstFields.clear;
 queryPrint.first;

 {read field names into list}
  begin
   for iInc := 1 to (queryPrint.FieldCount) do
    begin
     lstFields.Items.add(queryPrint.Fields[iInc -1].FieldName);
    end;
  end;
end;

{set query}
procedure TQueryDlg.SetQuery;
var
 i: integer;
begin

  {initial statement}
  FSQL := 'select ';

  {add field names to sql statement}
  for i := 0 to (lstFields.Items.Count -1) do
   begin
    {if last field name, don't add a comma}
    if i <> (lstFields.Items.Count -1) then
     FSQL := FSQL + FTable +'."'+ lstFields.Items[i] +'",'
    else
     FSQL := FSQL + FTable +'."'+ lstFields.Items[i] +'" '
   end;


  FSQL := FSQL +' from '+ FTable;

  {add where clauses}
  if FSQLWhereClause <> nil then
  if FSQLWhereClause.count > 0 then
   begin
    FSQL := FSQL + ' WHERE ';
    for i := 0 to (FSQLWhereClause.count -1) do
     begin
      FSQL := FSQL +' '+ FSQLWhereClause[i];
     end;
   end;


end;




{***buttons*********************************************************************}

{restore list}
procedure TQueryDlg.SpeedButton2Click(Sender: TObject);
begin
 SetList;
end;

{delete item from list}
procedure TQueryDlg.SpeedButton1Click(Sender: TObject);
begin
 lstFields.DeleteSelected;
end;

{cancel}
procedure TQueryDlg.BitBtn2Click(Sender: TObject);
begin
 modalResult := mrCancel;
end;

{ok}
procedure TQueryDlg.BitBtn1Click(Sender: TObject);
begin
 if lstFields.Items.Count > 0 then
  begin
   setQuery;
   modalResult := mrOK;
  end
 else
  modalResult := mrCancel;
end;


{filter}
procedure TQueryDlg.SpeedButton3Click(Sender: TObject);
begin
 {set data}
 filterDlg.SetComboTab;
 filterDlg.SetListBox;
 {show}
 if filterDlg.CustShowModal = mrOK then
  begin
   FSQLWhereClause := FilterDlg.FSQL;
  end;
end;


{***form's preferences**********************************************************}

{on create}
procedure TQueryDlg.FormCreate(Sender: TObject);
begin

 {read data from TQuery in main form}
 queryPrint.databaseName := PrintDlg.QueryPrint.DatabaseName;
 queryPrint.SQL.clear;
 queryPrint.SQL.Add(PrintDlg.FSQL);
 queryPrint.active := true;
 FTable := PrintDlg.FTable;

 {initiate this form}
 setList;

end;

end.
