unit ResIco1;

interface

uses
  SysUtils, Classes, Forms, ExtCtrls;

type
  TForm1 = class(TForm)
	 Timer1: TTimer;
	 procedure FormActivate(Sender: TObject);
	 procedure Timer1Timer(Sender: TObject);
  private
	 { Private declarations }
	OldUserFreePercent: longint;
	OldGDIFreePercent: longint;
	procedure CheckResources;
  public
	 { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses ToolHelp;

{$R *.DFM}

procedure TForm1.CheckResources;
var
  HeapInfo: PSysHeapInfo;
begin
  new(HeapInfo);
  try
    with HeapInfo^
    do begin
       dwSize := SizeOf(TSysHeapInfo);
       if not SystemHeapInfo( HeapInfo)
       then raise exception.create('Error calling SystemHeapInfo');
       if (wUserFreePercent <> OldUserFreePercent) or
          (wGDIFreePercent <> OldGDIFreePercent)
       then begin
	    OldUserFreePercent := wUserFreePercent;
	    OldGDIFreePercent  := wGDIFreePercent;
            Application.Title := format('U=%d.2%%%sG=%d.2%%', [OldUserFreePercent, #13,OldGDIFreePercent]);
       end;
    end;
  finally
    dispose(HeapInfo);
  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  CheckResources;
  Application.Minimize;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  CheckResources;
end;

end.
