{$X+}
unit Test;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,wavemix, StdCtrls, Buttons, ExtCtrls, Tilemap;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    Label1: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    MixSession : THandle;
    wave1,
    wave2,
    wave3,
    wave4 : pointer;

    procedure PlayWave(channel : integer; wave : pointer);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  info : TWaveMixInfo;

begin
  MixSession:=WaveMixInit;
  info.size:=sizeof(TWaveMixInfo);
  WaveMixGetInfo(@info);
  edit2.text:=IntToStr(info.major);
  edit3.text:=IntToStr(info.minor);
  edit4.text:=info.date;

  wave1:=WaveMixOpenWave(MixSession,'button.wav',0,WMIX_FILE);
  wave2:=WaveMixOpenWave(MixSession,'guide.wav',0,WMIX_FILE);
  wave3:=WaveMixOpenWave(MixSession,'stop.wav',0,WMIX_FILE);
  wave4:=WaveMixOpenWave(MixSession,'unable.wav',0,WMIX_FILE);
  WaveMixOPenChannel(MixSession,0,WMIX_ALL);

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  WaveMixFreeWave(MixSession,wave4);
  WaveMixFreeWave(MixSession,wave3);
  WaveMixFreeWave(MixSession,wave2);
  WaveMixFreeWave(MixSession,wave1);
  WaveMixCloseSession(MixSession);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  WaveMixActivate(MixSession,TRUE);
end;

procedure TForm1.FormDeactivate(Sender: TObject);
begin
  WaveMixActivate(MixSession,FALSE);
end;

procedure TForm1.PlayWave(channel : integer; wave : pointer);
var
  Mix : TMixPlayParams;

begin
  Mix.size:=SizeOf(TMixPlayParams);
  Mix.MixSession:=MixSession;
  Mix.Channel:=channel;
  Mix.lpMixWave:=wave;
  Mix.WndNotify:=0;
{  Mix.Flags:=WMIX_CLEARQUEUE; }
  Mix.Flags:=WMIX_USELRUCHANNEL;
  Mix.Loops:=0;
  WaveMixPlay(@Mix);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  PlayWave(0,wave1);
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  PlayWave(1,Wave2);
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
  PlayWave(2,Wave3);
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
  PlayWave(3,Wave4);
end;

end.
