unit Tilemap;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls;

type
  TTiledBitmap = class(TPaintBox)
  private
    { Private declarations }
    FBitMap : TBitMap;

    procedure SetBitmap(value : TBitMap);
  protected
    { Protected declarations }
    procedure Paint; override;
  public
    { Public declarations }
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property top;
    property left;
    property width;
    property height;
    property BitMap : TBitMap read FBitmap write SetBitMap;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Additional', [TTiledBitmap]);
end;

constructor TTiledBitmap.create(AOwner:TComponent);
begin
  inherited Create(AOwner);

  FBitMap:=TBitMap.Create;
  width:=65;
  height:=65;
end;

procedure TTiledBitmap.SetBitmap(value : TBitMap);
begin
  if FBitmap<>value then
    begin
      FBitmap.assign(value);
      Invalidate;
    end;
end;

procedure TTiledBitmap.Paint;
var
  i,j,nx,ny : integer;

begin
  if not fBitmap.Empty then
    with canvas do
      begin
        nx:=width div fBitmap.width;
        ny:=height div fBitmap.height;

        for i:=0 to nx do
          for j:=0 to ny do
            draw(i*fBitmap.width,j*fBitmap.height,fBitmap);
      end;
end;

destructor TTiledBitmap.destroy;
begin
  fBitmap.free;
  inherited destroy;
end;

end.
