{TTile - A simple tile component - Casey Charlton 13/8/95
                                   casey@larouss.demon.co.uk

       Freeware - Use and enjoy, no charge may be made for this
       component. If you like, and use this component, please drop
       me an email. If you make a useful modification please send
       me a copy.

Descendant of TImage:

This component is in response to a number of requests for a similar
function on the internet newsgroups.

It has one additional property : Tile, which should be set to
the bitmap to be tiled.

Use the MakeTiles method to tile the bitmap into the main image.

e.g.

Tile1.Tile := MyBitmap;
Tile1.MakeTiles;

To cover a form set the Align property to alClient.
}

unit Tiles;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls;

type
  TTile = class(TImage)
  private
    FTile : TBitmap;
    procedure SetTile(value : TBitmap);
  protected
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Tile : TBitmap read FTile write SetTile;
    procedure MakeTiles;
  end;

procedure Register;

implementation

constructor TTile.Create(AOwner : TComponent);
begin
     inherited Create(AOwner);
     FTile := TBitmap.Create;
end;

destructor TTile.Destroy;
begin
     FTile.Free;
     inherited Destroy;
end;

procedure TTile.SetTile(value:TBitmap);
begin
     FTile.Assign(value);
end;

procedure TTile.MakeTiles;
var
num_across, num_down,
yoff, xoff,
y_coord, x_coord,
y, x : integer;
begin
     num_across := (Width div Tile.Width) + 1;
     num_down := (Height div Tile.Height) +1;

     xoff := (Width - ((num_across + 1) * Tile.Width)) div 2;
     yoff := (Height - ((num_down + 1) * Tile.Height)) div 2;

     for x := 0 to num_across do
         for y := 0 to num_down do
             begin
                  x_coord := (x * Tile.Width) + xoff;
                  y_coord := (y * Tile.Height) + yoff;

                  Canvas.Draw(x_coord, y_coord, Tile);
             end;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TTile]);
end;

end.
