unit Wavemix;
{ Conversion from wavemix.h to Delphi by Daniel Parnell 11th August 1995 }

interface
uses wintypes;

const
  WMIX_QUEUEWAVE=$00;
  WMIX_CLEARQUEUE=$01;
  WMIX_USELRUCHANNEL=$02;
  WMIX_HIPRIORITY=$04;
  WMIX_WAIT=$08;
  WMIX_CONFIG_CHANNELS=$01;
  WMIX_CONFIG_SAMPLINGRATE=$02;
  WMIX_FILE=$0001;
  WMIX_RESOURCE=$0002;
  WMIX_OPENSINGLE=0;
  WMIX_OPENALL=1;
  WMIX_OPENCOUNT=2;
  WMIX_ALL=$0001;
  WMIX_NOREMIX=$0002;

  MONO=1;
  STEREO=2;
  SR_11024=11;
  SR_22050=22;
  SR_44100=44;

type
  PMixPlayParams=^TMixPlayParams;
  TMixPlayParams=record
    Size       : word;
    MixSession : THandle;
    Channel    : integer;
    lpMixWave  : pointer;
    WndNotify  : HWND;
    Flags      : longint;
    loops      : word;
  end;

  PWaveMixInfo=^TWaveMixInfo;
  TWaveMixInfo=record
    Size        : word;
    major,minor : byte;
    date        : array[0..11] of char;
    formats     : longint;
  end;

  PMixConfig=^TMixConfig;
  TMixConfig=record
    size        : word;
    flags       : longint;
    channels    : word;
    SampleRate : word;
  end;

function WaveMixGetInfo(lpWaveMixInfo:PWaveMixInfo):word;
function WaveMixInit:THandle;
function WaveMixConfigureInit(lpConfig:PMixConfig):THandle;
function WaveMixActivate(MixSession:THandle; activate:boolean):word;
function WaveMixOpenWave(MixSession:THandle; WaveFileName:PChar; inst:THandle; flags:longint):pointer;
function WaveMixOpenChannel(MixSession:THandle; channel:integer; flags:longint):word;
function WaveMixPlay(MixPlayParams:PMixPlayParams):word;
function WaveMixFlushChannel(MixSession:THandle; channel:integer; flags:longint):word;
function WaveMixCloseChannel(MixSession:THandle; channel:integer; flags:longint):word;
function WaveMixFreeWave(MixSession:THandle; lpMixWave:pointer):word;
function WaveMixCloseSession(MixSession:THandle):word;
procedure WaveMixPump;

implementation

function WaveMixGetInfo(lpWaveMixInfo:PWaveMixInfo):word; external 'WAVEMIX';
function WaveMixInit:THandle; external 'WAVEMIX';
function WaveMixConfigureInit(lpConfig:PMixConfig):THandle; external 'WAVEMIX';
function WaveMixActivate(MixSession:THandle; activate:boolean):word; external 'WAVEMIX';
function WaveMixOpenWave(MixSession:THandle; WaveFileName:PChar; inst:THandle; flags:longint):pointer; external 'WAVEMIX';
function WaveMixOpenChannel(MixSession:THandle; channel:integer; flags:longint):word; external 'WAVEMIX';
function WaveMixPlay(MixPlayParams:PMixPlayParams):word; external 'WAVEMIX';
function WaveMixFlushChannel(MixSession:THandle; channel:integer; flags:longint):word; external 'WAVEMIX';
function WaveMixCloseChannel(MixSession:THandle; channel:integer; flags:longint):word; external 'WAVEMIX';
function WaveMixFreeWave(MixSession:THandle; lpMixWave:pointer):word; external 'WAVEMIX';
function WaveMixCloseSession(MixSession:THandle):word; external 'WAVEMIX';
procedure WaveMixPump; external 'WAVEMIX';

end.
