unit Frrul;
{based on RULERS By Bill Murto, 73730,2505 No Copyright. Free. Enjoy.}
{ widely (<g>) modified by Olivier Dahan, 100531,163 for international metric system
  Free too, enjoy too. and forget inches... }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms;

type
  THFrRUL = class(TGraphicControl)
  private
    { Private declarations }
    fHRulerAlign: TAlign;
    procedure SeTHFrRULAlign(Value: TAlign);
  protected
    { Protected declarations }
    procedure Paint; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property AlignHRuler: TAlign read fHRulerAlign write SeTHFrRULAlign default alNone;
    property Color default clYellow;
    property Height default 33;
    property Width default 200;
    property Visible;
  end;

  type
  TVFrRUL = class(TGraphicControl)
  private
    { Private declarations }
    fVRulerAlign: TAlign;
    procedure SeTVFrRULAlign(Value: TAlign);
  protected
    { Protected declarations }
    procedure Paint; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property AlignVRuler: TAlign read fVRulerAlign write SeTVFrRULAlign default alNone;
    property Color default clYellow;
    property Height default 200;
    property Width default 33;
    property Visible;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('graph', [THFrRUL, TVFrRUL]);
end;

procedure THFrRUL.SeTHFrRULAlign(Value: TAlign);
begin
  if Value in [alTop, alBottom, alNone] then
  begin
    fHRulerAlign := Value;
    Align := Value;
  end;
end;

constructor THFrRUL.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  AlignHRuler := alNone;
  Color := clYellow;
  Height := 33;
  Width := 200;
end;

procedure THFrRUL.Paint;
var a10th, N, X : word;
begin
  a10th := Trunc(Screen.PixelsPerInch / 25.4); { 1 inch = 2,54 centimeters }
  N := 0; X := 0;
  with Canvas do
  begin
    Brush.Color := Color;
    FillRect(ClientRect);
    with ClientRect do
      Rectangle(Left, Top, Right, Bottom);
    while X < Width do
    begin
      MoveTo(X, 1); { 3 6 12 -> 2 5 10 }
      LineTo(X, 6*(2 +
        byte(N mod 5 = 0) +
        byte(N mod 10 = 0)));
      if (N > 0) and (N mod 10 = 0) then
        TextOut(PenPos.X+2, 9, IntToStr(N div 10));
      N := N + 1;
      X := X + a10th;
    end;
  end;
(* Original code in inches
  a12th := Screen.PixelsPerInch div 12;
  N := 0; X := 0;
  with Canvas do
  begin
    Brush.Color := Color;
    FillRect(ClientRect);
    with ClientRect do
      Rectangle(Left, Top, Right, Bottom);
    while X < Width do
    begin
      MoveTo(X, 1);
      LineTo(X, 6*(1 + byte(N mod 3 = 0) +
        byte(N mod 6 = 0) +
        byte(N mod 12 = 0)));
      if (N > 0) and (N mod 12 = 0) then
        TextOut(PenPos.X+3, 9, IntToStr(N div 12));
      N := N + 1;
      X := X + a12th;
    end;
  end;
*)
end;
{*********************************************}
procedure TVFrRUL.SeTVFrRULAlign(Value: TAlign);
begin
  if Value in [alLeft, alRight, alNone] then
  begin
    fVRulerAlign := Value;
    Align := Value;
  end;
end;

constructor TVFrRUL.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  AlignVRuler := alNone;
  Color := clYellow;
  Height := 200;
  Width := 33;
end;

procedure TVFrRUL.Paint;
var a5th, N, Y : word;
begin
  a5th := Trunc(Screen.PixelsPerInch / (2.54*5));
  N := 0; Y := 0;
  with Canvas do
  begin
    Brush.Color := Color;
    FillRect(ClientRect);
    with ClientRect do
      Rectangle(Left, Top, Right, Bottom);
    while Y < Height do
    begin
      MoveTo(1, Y);
      LineTo(6*(1 +
        byte(N mod 5 = 0)),Y);
      if (N > 0) and (N mod 5 = 0) then
        TextOut(12, PenPos.Y-16, IntToStr(N div 5));
      N := N + 1;
      Y := Y + a5th;
    end;
  end;
{ original code
  a6th := Screen.PixelsPerInch div 6;
  N := 0; Y := 0;
  with Canvas do
  begin
    Brush.Color := Color;
    FillRect(ClientRect);
    with ClientRect do
      Rectangle(Left, Top, Right, Bottom);
    while Y < Height do
    begin
      MoveTo(1, Y);
      LineTo(6*(2 + byte(N mod 3 = 0) +
        byte(N mod 6 = 0)),Y);
      if (N > 0) and (N mod 6 = 0) then
        TextOut(12, PenPos.Y-16, IntToStr(N div 6));
      N := N + 1;
      Y := Y + a6th;
    end;
  end;
}
end;

end.
