{
   TNumPad - your basic numeric entry pad.
   My first Delphi component, so don't laugh at the mistakes and terrible code,
   I'm working on it.  No copyrights, this is freeware, use it, abuse it,
   make it compute PI, I don't care.  Jus don't blame me if something blows up.

   Author : Thomas Hill, dba t.h.ink Software
            hillt@ionet.net (or) hillt@sill-emh.army.mil

   Version : First working one

   Revision history:  Oct 14, 1995  First cut..How do you make the *(*^#$^ thing
                      appear at design time??  Run time looks okay, sort of.
                      Oct 16, 1995  Okay, I figured out the design time display.
                      Where would I be without the VCL source?  That Component
                      Writer's Guide is the bottom of the pits!
                      Oct 18, 1995  Finally got the keyboard interface to work.
                      Package up for public sacrifice.

   Improvements : Fer sure.  More pad styles (any ideas?)
                  Limit minimum size so you can read the buttons.
                  (Thought I had this, but it doesn't listen to me)
                  Make Pad layout and button glyphs design/run-time properties.

}
unit Numpad;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;
{ TCustomControl }
type
  TPadStyle = (psCalc,psPhone,psHex);
  TNumPad = class(TCustomPanel)
  private
    FPadStyle : TPadStyle;
    FCurChar : char;
    FBtnFont : TFont;
    FOnBtnClick : TNotifyEvent;
    FOnKeyPress : TKeyPressEvent;
    Buttons : array[0..15] of TButton;

  protected
    procedure SetPadStyle(Value : TPadStyle);
    procedure DefineButtons;
    procedure BtnClick(Sender : TObject);
    property Caption;
    procedure AdjustSize(W,H : integer);
    procedure BtnKeyPress(Sender : TObject; var Key : char); 

  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy;
    property CurrentChar : char read FCurChar;
    procedure WMSize(var message : TWMSize); message WM_SIZE;

  published
    property Color default clBtnFace;
    property Width default 150;
    property Height default 150;
    property BevelInner default bvLowered;
    property BevelOuter default bvNone;
    property BevelWidth default 1;
    property PadStyle : TPadStyle read FPadStyle write SetPadStyle;
    property Align;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Ctl3D;
    property ParentCtl3D;
    property ParentShowHint;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnEnter;
    property OnExit;
    property OnBtnClick : TNotifyEvent read FOnBtnClick write FOnBtnClick;
    property OnKeyPress : TKeyPressEvent read FOnKeyPress write FOnKeyPress;
  end;

procedure Register;

implementation

const
     MinWidth = 75;
     MinHeight = 75;
     CalcCaps = '789/456X123-0.=+';
     PhoneCaps = '123456789*0#';
     HexCaps = 'CDEF89AB45670123';

procedure Register;
begin
  RegisterComponents('Custom', [TNumPad]);
end;

constructor TNumPad.Create(AOwner : TComponent);

begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle - [csAcceptsControls, csSetCaption] +
    [csFramed, csOpaque];
  Color := clBtnFace;
  Width := 150;
  Height := 150;
  BevelInner := bvLowered;
  BevelOuter := bvNone;
  BevelWidth := 1;
  FPadStyle := psCalc;
  fillchar(Buttons,sizeof(Buttons),0);
  FCurChar := ' ';
  Caption := ' ';
  Visible := TRUE;
  DefineButtons;
end;

procedure TNumPad.SetPadStyle(Value : TPadStyle);

begin
  if FPadStyle <> Value then
  begin
    FPadStyle := Value;
    DefineButtons;
  end;
end;

procedure TNumPad.DefineButtons;

var
   i,bx,by : integer;
   cx,cy : integer;
   cw,ch : integer;

begin
  Hide;
  if Buttons[0] <> nil then
  for i := 0 to 15 do if Buttons[i] <> nil then Buttons[i].Free;
  fillchar(Buttons,sizeof(Buttons),0);
  cx := BevelWidth * 2 + 2;
  cy := BevelWidth * 2 + 2;
  case FPadStyle of
    psCalc : begin
               bx := (Width - (4 * BevelWidth) - (8 * BevelWidth)) div 4;
               by := (Height - (4 * BevelWidth) - (8 * BevelWidth)) div 4;
               for i := 0 to 15 do
               begin
                 Buttons[i] := TButton.Create(Self);
                 with Buttons[i] do
                 begin
                   Parent := Self;
                   Left := cx; Top := cy;
                   Width := bx; Height := by;
                   Caption := Copy(CalcCaps,i + 1,1);
                   Visible := TRUE;
                   OnClick := BtnClick;
                   OnKeyPress := BtnKeyPress;
                 end;
                 cx := cx + bx + (2 * BevelWidth);
                 if i mod 4 = 3 then
                 begin
                   cx :=  BevelWidth * 2 + 2;
                   cy := cy + by + (2 * BevelWidth);
                 end;
               end;
             end;
   psPhone : begin
               bx := (Width - (4 * BevelWidth) - (8 * BevelWidth)) div 3;
               by := (Height - (4 * BevelWidth) - (8 * BevelWidth)) div 4;
               for i := 0 to 11 do
               begin
                 Buttons[i] := TButton.Create(Self);
                 with Buttons[i] do
                 begin
                   Parent := Self;
                   Left := cx; Top := cy;
                   Width := bx; Height := by;
                   Caption := Copy(PhoneCaps,i + 1,1);
                   Visible := TRUE;
                   OnClick := BtnClick;
                   OnKeyPress := BtnKeyPress;
                 end;
                 cx := cx + bx + (2 * BevelWidth);
                 if i mod 3 = 2 then
                 begin
                   cx :=  BevelWidth * 2 + 2;
                   cy := cy + by + (2 * BevelWidth);
                 end;
               end;
             end;
     psHex : begin
               bx := (Width - (4 * BevelWidth) - (8 * BevelWidth)) div 4;
               by := (Height - (4 * BevelWidth) - (8 * BevelWidth)) div 4;
               for i := 0 to 15 do
               begin
                 Buttons[i] := TButton.Create(Self);
                 with Buttons[i] do
                 begin
                   Parent := Self;
                   Left := cx; Top := cy;
                   Width := bx; Height := by;
                   Caption := Copy(HexCaps,i + 1,1);
                   Visible := TRUE;
                   OnClick := BtnClick;
                   OnKeyPress := BtnKeyPress;
                 end;
                 cx := cx + bx + (2 * BevelWidth);
                 if i mod 4 = 3 then
                 begin
                   cx :=  BevelWidth * 2 + 2;
                   cy := cy + by + (2 * BevelWidth);
                 end;
               end;
             end;
  end;
  for i := 0 to 15 do
  begin
    if Buttons[i] <> nil then
    begin
      Buttons[i].Font.Style := [fsBold];
    end;
  end;
  Show;
end;

procedure TNumPad.BtnClick(Sender : TObject);

begin
  inherited Click;
  FCurChar := (Sender as TButton).Caption[1];
  if Assigned(FOnBtnClick) then OnBtnClick(Self);
end;

procedure TNumPad.AdjustSize(W,H : integer);

var
   i : integer;
   cx,cy,bx,by : integer;

begin
  if (csLoading in ComponentState) then Exit;
  if W < MinWidth then W := MinWidth;
  if H < MinHeight then H := MinHeight;
  if Buttons[0] <> nil then
  begin
    cx := BevelWidth * 2 + 2;
    cy := BevelWidth * 2 + 2;
    case FPadStyle of
    psCalc : begin
               bx := (Width - (4 * BevelWidth) - (8 * BevelWidth)) div 4;
               by := (Height - (4 * BevelWidth) - (8 * BevelWidth)) div 4;
               for i := 0 to 15 do
               begin
                 if Buttons[i] <> nil then
                 with Buttons[i] do
                 begin
                   SetBounds(cx,cy,bx,by);
                 end;
                 cx := cx + bx + (2 * BevelWidth);
                 if i mod 4 = 3 then
                 begin
                   cx :=  BevelWidth * 2 + 2;
                   cy := cy + by + (2 * BevelWidth);
                 end;
               end;
             end;
    psPhone : begin
               bx := (Width - (4 * BevelWidth) - (8 * BevelWidth)) div 3;
               by := (Height - (4 * BevelWidth) - (8 * BevelWidth)) div 4;
               for i := 0 to 11 do
               begin
                 if Buttons[i] <> nil then
                 with Buttons[i] do
                 begin
                   SetBounds(cx,cy,bx,by);
                 end;
                 cx := cx + bx + (2 * BevelWidth);
                 if i mod 3 = 2 then
                 begin
                   cx :=  BevelWidth * 2 + 2;
                   cy := cy + by + (2 * BevelWidth);
                 end;
               end;
             end;
     psHex : begin
               bx := (Width - (4 * BevelWidth) - (8 * BevelWidth)) div 4;
               by := (Height - (4 * BevelWidth) - (8 * BevelWidth)) div 4;
               for i := 0 to 15 do
               begin
                 if Buttons[i] <> nil then
                 with Buttons[i] do
                 begin
                   SetBounds(cx,cy,bx,by);
                 end;
                 cx := cx + bx + (2 * BevelWidth);
                 if i mod 4 = 3 then
                 begin
                   cx :=  BevelWidth * 2 + 2;
                   cy := cy + by + (2 * BevelWidth);
                 end;
               end;
             end;
    end;
  end;
end;

procedure TNumPad.WMSize(var Message : TWMSize);

begin
  inherited;
  AdjustSize(Message.Width,Message.Height);
  if (Message.Width <> Width) or (Message.Height <> Height) then
    inherited SetBounds(Left,Top,Message.Width,Message.Height);
  Message.Result := 0;
end;

procedure TNumPad.BtnKeyPress(Sender : TObject; var Key : char);

begin
  Key := upcase(Key);
  case PadStyle of
    psCalc : begin
               if Pos(Key,CalcCaps) > 0 then
               begin
                 Buttons[Pos(Key,CalcCaps) - 1].Click;
                 Buttons[Pos(Key,CalcCaps) - 1].SetFocus;
               end;
             end;
   psPhone : begin
               if Pos(Key,PhoneCaps) > 0 then
               begin
                 Buttons[Pos(Key,PhoneCaps) - 1].Click;
                 Buttons[Pos(Key,PhoneCaps) - 1].SetFocus;
               end;
             end;
     psHex : begin
               if Pos(Key,HexCaps) > 0 then
               begin
                 Buttons[Pos(Key,HexCaps) - 1].Click;
                 Buttons[Pos(Key,HexCaps) - 1].SetFocus;
               end;
             end;
  end;
  if Assigned(FOnKeyPress) then OnKeyPress(Sender,Key);
end;

destructor TNumPad.Destroy;

var
   i : integer;

begin
  if Buttons[0] <> nil then
  for i := 0 to 15 do if Buttons[i] <> nil then Buttons[i].Free;
  inherited Destroy;
end;

end.
