unit Ss;
{
     TSplashScreen (TM) Copyright 1995 Michael Caracena

    This component took me 1 week to code
    and is the first component I wrote.

    There are no known bugs.

    TSplashScreen has been tested
    1000 times using a loop in a project (projects)source code,
    creating and freeing a Form.

    Questions,
    comments,
    or reactions may be sent to :

    caracena@henge.com

    Happy Coding! :)

    ----------------------------
    RESTORE MY FAITH IN HUMANITY

    If you appreciate this example
    please send $2 in an envolope to:

          Michael Caracena
          4412 Pali Way
          Boulder,Co
          80301-3828

    The last time I did this was with(
    Rad1.zip -how to create custom, captionless
    windows (including a Mac-Like window) in Delphi.
    I requested $1 and I recieved $5 from 3 people.

    I had sent the UUENCODE version of Rad1.zip to 30 people requesting the source
    and posted the source code on the Delphi Super Page.

    Is my faith in Humanity restored yet?
--------------------------------------------

    The following source code is Copyright 1995 Michael Caracena
====================================================
}
interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, Forms, Menus,
  Graphics, StdCtrls,dialogs, mmsystem,mplayer;

const
	WM_PleaseDestroyMe = WM_User + 1;
type
TSplashScreen = class(TCustomcontrol)
 private
    FAutoSize: Boolean;
    FScreenCanvas: TCanvas;
    FDrawSplashFrame: Boolean;
    FEnableDelay: Boolean;
    FDelayTime: Integer;
    FFillScreen: Boolean;
    FFrameTopColor: Tcolor;
    FFrameLeftColor: Tcolor;
    FFrameBottomColor: Tcolor;
    FFrameRightColor: Tcolor;
    FFrameWidth: integer;
    FSplash: Boolean;
    FTile: Boolean;
    FRepaintWindows: Boolean;
    FTileBitmap: TBitmap;
    FSplashBitmap:Tbitmap;
    FReserved: Byte;
    DeskTopWindow: Thandle;
    Hc: Hcursor;
    ScreenDC:HDC;

    function GetCanvas: TCanvas;
    procedure SetAutoSize(Value: Boolean);
    Procedure SetDelayTime(Value: Integer);
    Procedure SetEnableDelay(Value: Boolean);
    procedure SetFrameBottomColor(Value: TColor);
    procedure SetFrameLeftColor(Value: Tcolor);
    procedure SetFrameTopColor(Value: Tcolor);
    procedure SetFrameRightColor(Value: Tcolor);
    procedure SetframeWidth(Value: integer);
    Procedure SetDrawSplashFrame(Value: Boolean);
    procedure SetTileBitmap(Value: TBitmap);
    procedure SetSplashBitmap(Value: TBitmap);
    procedure PictureChanged(Sender: TObject);
    procedure SplashPictureChanged(Sender: TObject);
    procedure PaintWindow(dc: hdc);override;
    Procedure DelphiFrameDesignTime(x1,y1,x2,y2: integer);
    {------}
    procedure WMPleaseDestroyMe(var m : TMessage);
              message WM_PleaseDestroyMe;
    property Visible;
    property Enabled;
    property hint;
    property cursor;

  protected
    function GetPalette: HPALETTE; override;
    procedure Paint; override;
  public
    property Canvas: TCanvas read GetCanvas;
    Procedure DelphiFrame(x1,y1,x2,y2: integer);
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Delay(msecs:integer);
    property ScreenCanvas: TCanvas read FScreenCanvas;
    procedure SplashMe;
    Procedure TileScreen;
    Procedure Repaintall;
    procedure PlayWav(FileName: String;WFlags: word);
    procedure PlayMIDI(FileName: String; wait: boolean);
    procedure PlayAVI(FileName: String; Wait: Boolean);
  published
    property AutoSize: Boolean read FAutoSize write SetAutoSize default False;

    property DelayEnabled: Boolean read FEnableDelay write SetEnableDelay;
    property DelayTime: integer read FDelayTime write SetDelayTime;
    property DrawSplashFrame: Boolean read FDrawSplashFrame write SetDrawSplashFrame default False;
    property FrameBColor: Tcolor read FFrameBottomColor Write SetFramebottomColor;
    property FrameLColor: Tcolor read FFrameLeftColor write SetFrameLeftColor;
    property FrameTColor: Tcolor read FFrameTopColor write SetFrameTopColor;
    property FrameRColor: Tcolor read FFrameRightColor write SetFrameRightColor;
    property FrameWidth: Integer read FFrameWidth write SetFrameWidth;
    property Splash: Boolean read FSplash write FSplash;
    property Tile: Boolean read FTile write FTile;
    property RepaintWindows: Boolean read FRepaintWindows write FRepaintWindows;
    property TileBitmap: TBitmap read FTileBitmap write SetTileBitmap;
    property SplashBitmap: TBitmap read FSplashBitmap write SetSplashbitmap;
    end;

{ TSplash! }
procedure register;
implementation

{CREATE AND DESTROY PROCEDURES}
constructor TSplashScreen.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FTileBitmap:=TBitmap.Create;
  FSplashBitmap := TBitmap.Create;

  {Create ScreenCanvas}
  FScreenCanvas:=TCanvas.Create;
  if CsDesigning in Componentstate then
  begin
         splashBitmap.OnChange := PictureChanged;
         FTileBitmap.OnChange:=PictureChanged;
  end
     else
     begin
            {Initialize Screen}
        ScreenDC:=CreateDC('DISPLAY',NIL,NIL,NIL);
        ScreenCanvas.handle:=ScreenDC;
        SplashBitmap.OnChange:=SplashPictureChanged;

     end;
  Height := 120;
  Width := 200;
  FDelayTime:=2000;
  FEnableDelay:=False;
  FFramewidth:=2;
  FSplash:=true;
  FTile:=False;
  FRepaintWindows:=True;
  RepaintWindows:=True;
  enabled:=true;
{Frame Colors}
  FFrameleftColor:=clwhite;
  FFrameTopColor:=ClWhite;
  FFrameRightColor:=clgray;
  FFrameBottomColor:=Clgray;
end;
Destructor TSplashScreen.Destroy;
begin
  FTileBitmap.free;
  FSplashBitmap.Free;
  FScreenCanvas.Free;

  if CsDesigning in ComponentState then
  begin
      inherited Destroy;
      exit;
  end
  else
  begin
     {messagebeep(mb_ok);}
     if RepaintWindows then RepaintAll;
     DeleteObject(ScreenDc);

     inherited Destroy;
  end;
end;
Procedure TSplashScreen.SetAutoSize;
begin
     FAutoSize:= not FAutoSize;
     if autosize then
        begin
             inherited width:=Splashbitmap.width;
             inherited height:=SplashBitmap.height;
             if DrawSplashFrame then
                begin
                     inherited width:=inherited width+ (FrameWidth*2);
                     inherited height:=inherited height + (FrameWidth*2);
                end;
             invalidate;
        end;
end;

{--DELAY PROCEDURES--}
Procedure TSplashScreen.SetDelayTime(Value: integer);
begin
     FDelayTime:=Value;
end;
Procedure TSplashScreen.SetEnableDelay(Value: Boolean);
begin
     FEnableDelay:=Value;
end;

{--FRAME--}
procedure TSplashScreen.SetFrameWidth(Value: integer);
begin
     if value<=1 then value:=2;
     FFrameWidth:=Value;
     invalidate;
end;
procedure TSplashScreen.SetDrawSplashFrame(Value: Boolean);
begin
  FDrawSplashFrame := Value;
  invalidate;
end;
{Set -Frame Colors}

procedure TSplashScreen.SetFrameBottomColor(Value: Tcolor);
begin
     FFrameBottomColor:=Value;
     invalidate;
end;

procedure TSplashScreen.SetFrameleftColor(Value: Tcolor);
begin
     FFrameLeftColor:=Value;
     invalidate;
end;
procedure TSplashScreen.SetFrameRightColor(Value: Tcolor);
begin
     FFrameRightColor:=Value;
     Invalidate;
end;
procedure TSplashScreen.SetFrameTopColor(Value: Tcolor);
begin
     FFrameTopColor:=Value;
     Invalidate;
end;

{SET - BITMAPS}
procedure TSplashScreen.SetTileBitmap(Value: TBitmap);
begin
  FTileBitmap.Assign(Value);
end;
procedure TSplashScreen.SetSplashBitmap(Value: TBitmap);
begin
  FSplashBitmap.Assign(Value);
end;
{------- Get Palette and Canvas Functions -------}
function TSplashScreen.GetPalette: HPALETTE;
begin
  Result := 0;
  if FSplashBitmap is TBitmap then
     Result := TBitmap(Splashbitmap).Palette;
end;
function TSplashScreen.GetCanvas: TCanvas;
var
  Bitmap: TBitmap;
begin
  if SplashBitmap = nil then
  begin
    Bitmap := TBitmap.Create;
    try
       Bitmap.Width := Width;
       Bitmap.Height := Height;
       SplashBitmap := Bitmap;
    finally
       Bitmap.Free;
    end;
  end;
  if SplashBitmap is TBitmap then
     Result := TBitmap(SplashBitmap).Canvas
  else
     raise EInvalidOperation.Create('Error');
  end;

{PICTURE CHANGED}
procedure TSplashScreen.PictureChanged(Sender: TObject);
begin
  if (SplashBitmap is TBitmap)
     and (SplashBitmap.Width = Width)
     and (SplashBitmap.Height = Height)
     then
         ControlStyle := ControlStyle + [csOpaque]
     else
         ControlStyle := ControlStyle - [csOpaque];
  Invalidate;
end;

{PictureChange routine during execution of application}
procedure TSplashScreen.SplashPictureChanged(Sender: TObject);
begin
IF CSDESIGNING IN COMPONENTSTATE THEN EXIT;

   {Draw Bitmaps}
       If (TileBitmap<>nil) and (Tile) then TileScreen;
       If Splash then splashme;
   {Delay???}
       If DelayEnabled then Delay(DelayTime);
   {Change OnChange for SplashBitmap}
       SplashBitmap.Onchange:=Nil;
end;

{Design time paint procedure}
procedure TSplashScreen.Paint;
var
  Dest: TRect;
  CLeft, Ctop: integer;
  {Tile Vars}
  x,y,xend,yend:integer;
  SrcRect,Dstrect,temprect: Trect;
begin
if csDesigning in ComponentState then
begin
     Dest := Rect(0, 0, SplashBitmap.Width, SplashBitmap.Height);

     if Tilebitmap<>nil then
     If (tilebitmap.width>0) and (TileBitmap.height>0) then
     begin
          x:=0;
          y:=0;
          xend:=width;
          yend:=height;

          Srcrect.top:=0; SrcRect.left:=0;
          SrcRect.right:=xend;
          Srcrect.bottom:=yend;

          repeat
                if x>=xend then
                begin
                     y:=y+Tilebitmap.height;
                     x:=0;
                end;
                inherited canvas.draw(x,y,Tilebitmap);
                x:=x+Tilebitmap.width;
          until y>yend;
 end;

 if width>SplashBitmap.width then
    cleft:=(width - Splashbitmap.width)div 2 else Cleft:=0;
 if height>SplashBitmap.height then
    cTop:=(height -SplashBitmap.height) div 2 else cTop:=0;

 Dest := Rect(cleft, Ctop, SplashBitmap.Width+cleft, SplashBitmap.Height+cTop);

 with inherited canvas do
 BEGIN
      StretchDraw(Dest, SplashBitmap);
      if DrawSplashFrame
         then DelphiFrameDesignTime(cleft,ctop,SplashBitmap.width+cleft,SplashBitmap.height+ctop);
 END;
 end;
 with inherited Canvas do
    begin
     {Draw Control Frame}
      refresh;
      Brush.Style:=bsClear;
      pen.style:=psdash;
      pen.width:=1;
      pen.color:=clBlack;
      Rectangle(0, 0, Width, Height);
    end;
end;
{Splash Routine}
Procedure TSplashScreen.SplashMe;
var
xcenter,ycenter: Integer;
begin
     If SplashBitmap=nil then exit;
     If (SplashBitmap.width=0) or (SplashBitmap.height=0) then exit;

     xcenter:=(screen.width div 2) - (SplashBitmap.width div 2);
     ycenter:=(screen.height div 2) - (SplashBitmap.height div 2);

     ScreenCanvas.draw(xcenter,ycenter,SplashBitmap);

     {Draws Frame}
     if DrawSplashFrame then
          DelphiFrame(xcenter,ycenter,xcenter+SplashBitmap.width,ycenter+SplashBitmap.height);

end;

{-------- TILE -------}
Procedure TSplashScreen.TileScreen;
var
   x,y,xend,yend:integer;
begin
  if Tilebitmap<>nil then
  If (tilebitmap.width>0) and (TileBitmap.height>0) then
  begin
      x:=0;
      y:=0;
      xend:=Screen.width;
      yend:=Screen.height;
      repeat
        if x>=xend then
          begin
             y:=y+(Tilebitmap.height);
             x:=0;
          end;
          Screencanvas.draw(x,y,Tilebitmap);
          x:=x+(Tilebitmap.width);
      until y>yend;
  end;

end;
{A Generic Frame Type }
Procedure TsplashScreen.DelphiFrame(x1,y1,x2,y2: integer);
var
   count: integer;
   OldPenStyle: TPenStyle;
   OldPenWidth: integer;
   OldPenColor: TColor;
   xx1,xx2,yy1,yy2: integer;
begin

xx1:=x1;xx2:=x2;yy1:=y1;yy2:=y2;

with ScreenCanvas do
begin
{save Pen Values}
     oldPenStyle:=Pen.style;
     OldPenWidth:=Width;
     OldPencolor:=Color;
{change Pen}
     pen.style:=psSolid;
     pen.width:=1;
{Draw}
     Pen.color:=FrameLColor;
for count:=1 to FrameWidth -1 do
begin
     moveto(x1-1,y2);
     lineto(x1-1,y1-1);          {left Side}
     x1:=x1-1;
     x2:=x2+1;
     y1:=Y1-1;
     y2:=y2+1;
end;
    x1:=xx1;x2:=xx2;y1:=yy1;y2:=yy2;
    Pen.color:=FrameTcolor;

for count:=1 to FrameWidth -1 do
begin
     moveto(x1-1,y1-1);
     lineto(x2,y1-1);            {Top Side}
     x1:=x1-1;
     x2:=x2+1;
     y1:=Y1-1;
     y2:=y2+1;
end;
    x1:=xx1;x2:=xx2;y1:=yy1;y2:=yy2;
    pen.color:=FrameRcolor;
for count:=1 to FrameWidth -1 do
begin
     moveto(x2+0,y1-1);
     lineto(x2+0,y2+0);          {RightSide}
     x1:=x1-1;
     x2:=x2+1;
     y1:=Y1-1;
     y2:=y2+1;
end;
    x1:=xx1;x2:=xx2;y1:=yy1;y2:=yy2;
     pen.color:=FrameBColor;
for count:=1 to FrameWidth -1 do
begin
     moveto(x2+0,y2+0);
     lineto(x1-1,y2+0);
     x1:=x1-1;
     x2:=x2+1;
     y1:=Y1-1;
     y2:=y2+1;
end;


     Pen.color:=clBlack;
     moveto(x1-1,y2);
     lineto(x1-1,y1-1); {bottom to top}
     lineto(x2,y1-1); {top to right}
     moveto(x2+0,y1-1);
     lineto(x2+0,y2+0);{righttop to Rightbottom}
     lineto(x1-1,y2+0);
{Reset Pen}
Pen.style:=oldPenStyle;
Pen.width:=OldPenWidth;
Pen.color:=OldPenColor;


end;

end;

Procedure TsplashScreen.DelphiFrameDesignTime(x1,y1,x2,y2: integer);
var
   count: integer;
   OldPenStyle: TPenStyle;
   OldPenWidth: integer;
   OldPenColor: TColor;
   xx1,xx2,yy1,yy2: integer;
begin

xx1:=x1;xx2:=x2;yy1:=y1;yy2:=y2;

with inherited canvas do
begin
{save Pen Values}
     oldPenStyle:=Pen.style;
     OldPenWidth:=Width;
     OldPencolor:=Color;
{change Pen}
     pen.style:=psSolid;
     pen.width:=1;
{Draw}
     Pen.color:=FrameLColor;
for count:=1 to FrameWidth -1 do
begin
     moveto(x1-1,y2);
     lineto(x1-1,y1-1);          {left Side}
     x1:=x1-1;
     x2:=x2+1;
     y1:=Y1-1;
     y2:=y2+1;
end;
    x1:=xx1;x2:=xx2;y1:=yy1;y2:=yy2;
    Pen.color:=FrameTcolor;

for count:=1 to FrameWidth -1 do
begin
     moveto(x1-1,y1-1);
     lineto(x2,y1-1);            {Top Side}
     x1:=x1-1;
     x2:=x2+1;
     y1:=Y1-1;
     y2:=y2+1;
end;
    x1:=xx1;x2:=xx2;y1:=yy1;y2:=yy2;
    pen.color:=FrameRcolor;
for count:=1 to FrameWidth -1 do
begin
     moveto(x2+0,y1-1);
     lineto(x2+0,y2+0);          {RightSide}
     x1:=x1-1;
     x2:=x2+1;
     y1:=Y1-1;
     y2:=y2+1;
end;
    x1:=xx1;x2:=xx2;y1:=yy1;y2:=yy2;
     pen.color:=FrameBColor;
for count:=1 to FrameWidth -1 do
begin
     moveto(x2+0,y2+0);
     lineto(x1-1,y2+0);
     x1:=x1-1;
     x2:=x2+1;
     y1:=Y1-1;
     y2:=y2+1;
end;


     Pen.color:=clBlack;
     moveto(x1-1,y2);
     lineto(x1-1,y1-1); {bottom to top}
     lineto(x2,y1-1); {top to right}
     moveto(x2+0,y1-1);
     lineto(x2+0,y2+0);{righttop to Rightbottom}
     lineto(x1-1,y2+0);
{Reset Pen}
Pen.style:=oldPenStyle;
Pen.width:=OldPenWidth;
Pen.color:=OldPenColor;


end;

end;

{Causes Splash to Destroy before window is painted}
procedure TSplashScreen.PaintWindow(dc: hdc);
begin
if CsDesigning in Componentstate then
   begin
        paint;
        exit;
   end;
Visible:=false;
postmessage(handle, WM_PleaseDestroyMe, 0, 0);
end;
procedure TSplashScreen.WMPleaseDestroyMe(var m : TMessage);
begin
	{messagebeep(mb_ok); {doesn't beep}
        destroy;{call destroy procedure}
end;

{Misc.}
procedure TSplashScreen.Delay(msecs:integer);
var
   FirstTickCount:longint;
   Msg: Tmsg;
begin
     FirstTickCount:=GetTickCount;
     repeat
     until ((GetTickCount-FirstTickCount) >= Longint(msecs));
end;

Procedure TSplashScreen.RepaintAll;
var
wnd,wnd2: Thandle;
begin
{InvalidateRect(GetActiveWindow,nil,true);}
wnd:=GetNextWindow(GetActiveWindow,GW_HwndNext);
if iswindowvisible(wnd)<>True then InvalidateRect(wnd,nil,true);
   repeat
      wnd2:=GetNextwindow(wnd,GW_HwndNext);
      if iswindowvisible(wnd2)<>True then InvalidateRect(wnd2,nil,true);
      wnd:=wnd2;
   until wnd2=0;
{InvalidateRect(GetDeskTopWindow,nil,true);}
end;

{Sound Support}
procedure TSplashScreen.PlayWav(FileName: String;WFlags: word);
var
fileNameChar: Array[0..253] of char;
begin
     Strpcopy(filenamechar,Filename);
     SndPlaySound(filenamechar,wFlags);
{
SND_SYNC
        The sound is played synchronously
        and the function does not return until the sound ends.
SND_ASYNC
         The sound is played asynchronously and
         the function returns immediately after
         beginning the sound. To terminate an
         asynchronously-played sound, call sndPlaySound
         with lpszSoundName set to NULL.
SND_NODEFAULT
         If the sound can't be found,
         the function returns silently
         without playing the default sound.
SND_MEMORY
          The parameter specified by
          lpszSoundNamepoints to an in-memory
          image of a waveform sound.
SND_LOOP
        The sound will continue to play repeatedly
        until sndPlaySound is called again with the
        lpszSoundName parameter set to NULL.
        You must also specify the SND_ASYNC flag to loop sounds.
SND_NOSTOP
        If a sound is currently playing,
        the function will immediately return FALSE without playing
        the requested sound.
}

end;
procedure TSplashScreen.PlayMIDI(FileName: string;wait: boolean);
var
   s1: string;
   s2: Array  [0..253]of char;
   aliasRandom: string;
   OpenStr: string;
   OpenAChar: array [0..253]of char;
   Ran1,Ran2: integer;
begin
     Ran1:=Random(34000);
     Ran2:=Random(34000);

     aliasrandom:=inttoStr(ran1)+ inttoStr(ran2);

     {Open Midi}
     OpenStr:='open ' + FileName + ' type sequencer alias '+ AliasRandom;
     StrpCopy(OpenAChar,OpenStr);
     mciSendString(OpenAChar{'open d:\formless\chopin.mid type sequencer alias poo'}
                   ,nil,0,0);

     {Play MIDI}
     s1:='play ' + AliasRandom;
     if wait=true then s1:=s1+' wait';
     strpcopy(s2,s1);
     mciSendString(S2,nil,0,0);

     if wait =true then mciSendString('close',nil,0,0);

end;
{Hmmm -not the best way, but it's doable!}
procedure TsplashScreen.PlayAVI(FileName: String; Wait: Boolean);
var
   player:Tmediaplayer;
   Aniform: Tform;
begin

aniform:=Tform.create(self);
aniform.position:=poScreenCenter;
Player:=TMediaPlayer.create(aniform);
player.parent:=aniform;
player.visible:=false;
player.filename:=Filename;
player.display:=aniform;
player.open;
player.wait:=true;

AniForm.Show;

player.play;
player.free;

AniForm.free;
end;

{Yeah}
procedure Register;
begin
     RegisterComponents('Samples', [TSplashScreen]);
end;
end.
