unit Uined1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Menus, Forms, Dialogs, StdCtrls, ExtCtrls, InEdit, Buttons;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    InPlaceEdit: TInEdit;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure InPlaceEditGoingOff(Sender: TObject; Reason: TGoingOffReason;
      Value: String; var AllowExit: Boolean);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  with ListBox1 do
    begin
      if
        (ItemIndex <> 9) and { protected item }
        (ItemIndex >= TopIndex) and
        (ItemIndex < TopIndex + ClientHeight div ItemHeight)
      then
        begin
          { Determine the rectangle of the highlighted item }
          InPlaceEdit.Top := (ItemIndex - TopIndex)*ItemHeight;
          InPlaceEdit.Height := ItemHeight;
          InPlaceEdit.Left := 2;
          InPlaceEdit.Width := ClientWidth;
          { Assign text to the editor }
          InPlaceEdit.Text := Items[ItemIndex];
          { Make it visible }
          InPlaceEdit.Visible := True;
          InPlaceEdit.SetFocus;
        end;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InPlaceEdit.Font.Assign( ListBox1.Font);
  InPlaceEdit.Parent := ListBox1;
end;

procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  { Allow listbox to go into the editing mode on SPACE or RETURN }
  If (Key = VK_RETURN) or (Key = VK_SPACE) then
    ListBox1Click(Self);
end;

procedure TForm1.InPlaceEditGoingOff(Sender: TObject; Reason: TGoingOffReason;
  Value: String; var AllowExit: Boolean);
var
  i,t: Integer;
begin

  { for test reasons do not allow item number 6 to change! }
  if
    (reason <> goEscape) and
    (ListBox1.ItemIndex = 5) and
    ( CompareStr(Value, '<unchangeable>') <> 0 )
  then
    begin
      AllowExit := False;
      exit;
    end;

  if reason <> goEscape then
    begin
      { it is important to save and restore ItemIndex and TopIndex }
      { while changing the item }
      i := ListBox1.ItemIndex;
      t := ListBox1.TopIndex;
      ListBox1.Items[i] := Value;
      ListBox1.ItemIndex := i;
      ListBox1.TopIndex := t;
    end;

  if (reason = goUp) or (reason = goLeft) then
      PostMessage(ListBox1.Handle, WM_KEYDOWN, VK_UP, 0)
  else if (reason = goDown) or (reason = goRight) then
      PostMessage(ListBox1.Handle, WM_KEYDOWN, VK_DOWN, 0)
  else if (reason = goHome) then
      PostMessage(ListBox1.Handle, WM_KEYDOWN, VK_HOME, 0)
  else if (reason = goEnd) then
      PostMessage(ListBox1.Handle, WM_KEYDOWN, VK_END, 0)
  else if (reason = goPgUp) then
      PostMessage(ListBox1.Handle, WM_KEYDOWN, VK_PRIOR, 0)
  else if (reason = goPgDn) then
      PostMessage(ListBox1.Handle, WM_KEYDOWN, VK_NEXT, 0);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Close;
end;

end.
