unit Viewunit;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, IniFiles, FileCtrl, ExtCtrls, StdCtrls, Buttons, MPlayer,
  TabNotBk, DBCtrls, DB, DBTables, Grids, DBGrids, Menus;

type
  TForm1 = class(TForm)
    TabNB: TTabbedNotebook;
    Panel1: TPanel;
    MediaPlayer1: TMediaPlayer;
    Image1: TImage;
    Panel2: TPanel;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FilterComboBox1: TFilterComboBox;
    FileListBox1: TFileListBox;
    bbClose: TBitBtn;
    Memo1: TMemo;
    DBGrid1: TDBGrid;
    Table1: TTable;
    DataSource1: TDataSource;
    Label2: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FileListBox1Change(Sender: TObject);
    procedure MediaPlayer1Notify(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FileListBox1DblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    AppFileName: string;
    Texts: string[80];
    Pictures: string[80];
    MultiMed: string[80];
    DBees: string[80];
    Resizing: boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FileListBox1Change(Sender: TObject);
var FileExt: string;
begin
   FileListBox1.ShowHint := False;
   FileExt := UpperCase(ExtractFileExt(FileListBox1.Filename));
   if Pos(FileExt, Pictures) > 0 then
     try
       TabNB.Pageindex := 1;
       Image1.Picture.LoadFromFile(FileListBox1.Filename);
       Image1.visible := True;
       Label2.Caption := UpperCase(FileListBox1.Filename);
     except
       Image1.visible := False;
       Label2.Caption := 'Error: Cannot Open This File';
   end else
   if Pos(FileExt, MultiMed) > 0 then
     try
       TabNB.Pageindex := 2;
       MediaPlayer1.Filename := FileListBox1.Filename;
       MediaPlayer1.Close;
       MediaPlayer1.Open;
       MediaPlayer1.DisplayRect := Rect(0,0,Panel1.Width,Panel1.Height);
       MediaPlayer1.Play;
       MediaPlayer1.Notify := True;
       Label3.Caption := UpperCase(FileListBox1.Filename);
     except
       Label3.Caption := 'Error: Cannot Open This File';
   end else
   if Pos(FileExt, Texts) > 0 then
     try
       FileListBox1.ShowHint := True;
       TabNB.Pageindex := 0;
       Memo1.Lines.Loadfromfile(FileListBox1.Filename);
       Label1.Caption := UpperCase(FileListBox1.Filename);
       Memo1.ShowHint := True;
     except
       Memo1.Lines.Clear;
       Label1.Caption := 'Error: Cannot Open This File';
   end else
   If Pos(FileExt, DBees) > 0 then
     try
       TabNB.Pageindex := 3;
       with Table1 do begin
         Close;
         DatabaseName := DirectoryListBox1.Directory;
         TableName := FileListBox1.Filename;
         Open;
       end;
       Label4.Caption := UpperCase(FileListBox1.Filename);
     except
       Label4.Caption := 'Error: Cannot Open This File';
   end;
end;

procedure TForm1.MediaPlayer1Notify(Sender: TObject);
begin
   if MediaPlayer1.NotifyValue=nvSuccessful then
     MediaPlayer1.Close;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  TabNB.Pageindex := 0;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  IniName: string;
begin
  AppFileName := ExtractFileName(Application.ExeName);
  Caption := Application.ExeName +
     '  (' + ChangeFileExt(AppFileName,'.INI') + ')';
  DirectoryListBox1.Directory := '\';
  Label1.Caption := '';
  Label2.Caption := '';
  Label3.Caption := '';
  Label4.Caption := '';

  IniName := ChangeFileExt(Application.ExeName,'.INI');
  IniFile := TIniFile.Create(IniName);
  With Inifile Do
    try
      FilterComboBox1.Filter := ReadString('Viewer','Filter',
         'Text Files|*.TXT;*.BAT;*.PAS;*.INI;*.CMD|'
        +'DB Files|*.DBF;*.DB|'
        +'Pictures|*.BMP;*.ICO;*.WMF|'
        +'MultiMedia|*.AVI;*.WAV;*.MID|'
        +'All Files|*.*');
      Texts := UpperCase(ReadString('Viewer','Text','.TXT.PAS.BAT.INI.CMD'));
      Pictures := UpperCase(ReadString('Viewer','Pictures','.BMP.ICO.WMF'));
      MultiMed := UpperCase(ReadString('Viewer','MultiMed','.AVI.WAV.MID'));
      DBees := UpperCase(ReadString('Viewer','DBees','.DBF.DB'));
    finally
      Free;
  end;
end;

procedure TForm1.FileListBox1DblClick(Sender: TObject);
var
  cmd: array[0..125] of char;
begin  {edit this file}
  strpcopy( cmd, 'notepad.exe ' + FileListBox1.FileName);
  winexec( cmd, SW_SHOWNORMAL);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
  IniName: string;
begin
  IniName := ChangeFileExt(Application.ExeName,'.INI');
  IniFile := TIniFile.Create(IniName);
  With Inifile Do
    try
      WriteString('Viewer','Filter',FilterComboBox1.Filter);
      WriteString('Viewer','Text',Texts);
      WriteString('Viewer','Pictures',Pictures);
      WriteString('Viewer','MultiMed',MultiMed);
      WriteString('Viewer','DBees',DBees);
    finally
      Free;
  end;
end;

end.
